Package: exploreSE
Title: Explorer for Your Bulk RNA Seq Analyses
Version: 0.99.5
Authors@R: 
    person("Jasper", "Spitzer", , "jasspitzer135@gmail.com", 
        role = c("aut", "cre"), comment = c(ORCID="0000-0001-9696-2092"))
Description: Interactive exploration of a Summarized experiment and associated DE analyses. A shiny
 app to inspect and interact with pre-calculated differential expression and functional 
 enrichment results, and to facilitate comparisons between multiple models. This is meant
 to be a tool for exploration and discussion, rather than analysis.
License: MIT + file LICENSE
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
Depends: R (>= 4.6.0)
Imports: BiocGenerics, clusterProfiler, colourpicker, DeeDeeExperiment,
        DESeq2, dplyr, DT, forcats, ggplot2, htmltools, magrittr,
        matrixStats, methods, msigdbr, org.Hs.eg.db, org.Mm.eg.db,
        plotly, purrr, readr, rlang, S4Vectors, shiny, shinyWidgets,
        stats, stringr, SummarizedExperiment, tibble, tidyr, tidyselect
Suggests: airway, BiocStyle, knitr, rmarkdown, testthat (>= 3.0.0)
URL: https://github.com/jaspitzer/exploreSE
BugReports: https://github.com/jaspitzer/exploreSE/issues
biocViews: ShinyApps, RNASeq, Visualization, GeneExpression, Pathways,
        GO
Config/testthat/edition: 3
Config/roxygen2/version: 8.0.0
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/exploreSE
git_branch: devel
git_last_commit: c0866f8
git_last_commit_date: 2026-08-18
Repository: Bioconductor 3.24
Date/Publication: 2026-08-20
NeedsCompilation: no
Packaged: 2026-08-20 21:57:59 UTC; biocbuild
Author: Jasper Spitzer [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-9696-2092>)
Maintainer: Jasper Spitzer <jasspitzer135@gmail.com>

<!-- README.md is generated from README.Rmd. Please edit that file -->

# exploreSE

<!-- badges: start -->

<!-- badges: end -->

The goal of exploreSE is to create and maintian a shiny app for
transcriptomic results presentation. It heavily relies on the
[SummarizedExperiment](https://www.bioconductor.org/packages/release/bioc/html/SummarizedExperiment.html)
and
[DeeDeeExperiment](https://bioconductor.org/packages//release/bioc/html/DeeDeeExperiment.html)
packages on bioconductor.

## Installation

You can install the development version of exploreSE from
[GitHub](https://github.com/) with:

``` r
# install.packages("pak")
pak::pak("jaspitzer/exploreSE")
```

## Example

Let’s say you’ve loaded in your data and created two separate models:

``` r
library(exploreSE)
library(airway)
#> Loading required package: SummarizedExperiment
#> Loading required package: MatrixGenerics
#> Loading required package: matrixStats
#> 
#> Attaching package: 'MatrixGenerics'
#> The following objects are masked from 'package:matrixStats':
#> 
#>     colAlls, colAnyNAs, colAnys, colAvgsPerRowSet, colCollapse,
#>     colCounts, colCummaxs, colCummins, colCumprods, colCumsums,
#>     colDiffs, colIQRDiffs, colIQRs, colLogSumExps, colMadDiffs,
#>     colMads, colMaxs, colMeans2, colMedians, colMins, colOrderStats,
#>     colProds, colQuantiles, colRanges, colRanks, colSdDiffs, colSds,
#>     colSums2, colTabulates, colVarDiffs, colVars, colWeightedMads,
#>     colWeightedMeans, colWeightedMedians, colWeightedSds,
#>     colWeightedVars, rowAlls, rowAnyNAs, rowAnys, rowAvgsPerColSet,
#>     rowCollapse, rowCounts, rowCummaxs, rowCummins, rowCumprods,
#>     rowCumsums, rowDiffs, rowIQRDiffs, rowIQRs, rowLogSumExps,
#>     rowMadDiffs, rowMads, rowMaxs, rowMeans2, rowMedians, rowMins,
#>     rowOrderStats, rowProds, rowQuantiles, rowRanges, rowRanks,
#>     rowSdDiffs, rowSds, rowSums2, rowTabulates, rowVarDiffs, rowVars,
#>     rowWeightedMads, rowWeightedMeans, rowWeightedMedians,
#>     rowWeightedSds, rowWeightedVars
#> Loading required package: GenomicRanges
#> Loading required package: stats4
#> Loading required package: BiocGenerics
#> Loading required package: generics
#> 
#> Attaching package: 'generics'
#> The following objects are masked from 'package:base':
#> 
#>     as.difftime, as.factor, as.ordered, intersect, is.element, setdiff,
#>     setequal, union
#> 
#> Attaching package: 'BiocGenerics'
#> The following objects are masked from 'package:stats':
#> 
#>     IQR, mad, sd, var, xtabs
#> The following objects are masked from 'package:base':
#> 
#>     anyDuplicated, aperm, append, as.data.frame, basename, cbind,
#>     colnames, dirname, do.call, duplicated, eval, evalq, Filter, Find,
#>     get, grep, grepl, is.unsorted, lapply, Map, mapply, match, mget,
#>     order, paste, pmax, pmax.int, pmin, pmin.int, Position, rank,
#>     rbind, Reduce, rownames, sapply, saveRDS, table, tapply, unique,
#>     unsplit, which.max, which.min
#> Loading required package: S4Vectors
#> 
#> Attaching package: 'S4Vectors'
#> The following object is masked from 'package:utils':
#> 
#>     findMatches
#> The following objects are masked from 'package:base':
#> 
#>     expand.grid, I, unname
#> Loading required package: IRanges
#> Loading required package: Seqinfo
#> Loading required package: Biobase
#> Welcome to Bioconductor
#> 
#>     Vignettes contain introductory material; view with
#>     'browseVignettes()'. To cite Bioconductor, see
#>     'citation("Biobase")', and for packages 'citation("pkgname")'.
#> 
#> Attaching package: 'Biobase'
#> The following object is masked from 'package:MatrixGenerics':
#> 
#>     rowMedians
#> The following objects are masked from 'package:matrixStats':
#> 
#>     anyMissing, rowMedians
library(DeeDeeExperiment)
#> Loading required package: SingleCellExperiment
library(DESeq2)
data(airway)
```

``` r
airway <- DESeqDataSet(airway, design = ~dex)
airway <- DESeq(airway)
#> estimating size factors
#> estimating dispersions
#> gene-wise dispersion estimates
#> mean-dispersion relationship
#> final dispersion estimates
#> fitting model and testing
baseline <- results(airway)

airway <- DESeqDataSet(airway, design = ~dex + cell)
airway <- DESeq(airway)
#> using pre-existing size factors
#> estimating dispersions
#> found already estimated dispersions, replacing these
#> gene-wise dispersion estimates
#> found already estimated gene-wise dispersions, removing these
#> mean-dispersion relationship
#> final dispersion estimates
#> found already estimated dispersions, removing these
#> fitting model and testing
cell_controlled <- results(airway)
```

These results can be added to the DeeDeeExperiment

``` r
airway <- addDEA(DeeDeeExperiment(airway), baseline)
airway <- addDEA(airway, cell_controlled)
```

``` r
airway
#> class: DeeDeeExperiment 
#> dim: 63677 8 
#> metadata(2): '' version
#> assays(4): counts mu H cooks
#> rownames(63677): ENSG00000000003 ENSG00000000005 ... ENSG00000273492
#>   ENSG00000273493
#> rowData names(62): gene_id gene_name ... cell_controlled_pvalue
#>   cell_controlled_padj
#> colnames(8): SRR1039508 SRR1039509 ... SRR1039520 SRR1039521
#> colData names(10): SampleName cell ... BioSample sizeFactor
#> reducedDimNames(0):
#> mainExpName: NULL
#> altExpNames(0):
#> dea(2): baseline, cell_controlled 
#> fea(0):
```

``` r
airway <- get.gos(obj = airway, NAME = "baseline", gene_type = "ENSEMBL")
#> 
#> 
#> Found 3424 gene sets in `enrichResult` object, of which 132 are significant.
#> Converting for usage within the DeeDeeExperiment framework...
#> ✔ Renamed FEA entries: "up_go" to "baseline_up_go"
#> Found 3589 gene sets in `enrichResult` object, of which 127 are significant.
#> Converting for usage within the DeeDeeExperiment framework...
#> ✔ Renamed FEA entries: "dn_go" to "baseline_down_go"
airway <- get.gos(obj = airway, NAME = "cell_controlled", gene_type = "ENSEMBL")
#> Found 2248 gene sets in `enrichResult` object, of which 23 are significant.
#> Converting for usage within the DeeDeeExperiment framework...
#> ✔ Renamed FEA entries: "up_go" to "cell_controlled_up_go"
#> Found 3205 gene sets in `enrichResult` object, of which 124 are significant.
#> Converting for usage within the DeeDeeExperiment framework...
#> ✔ Renamed FEA entries: "dn_go" to "cell_controlled_down_go"
```

``` r
airway
#> class: DeeDeeExperiment 
#> dim: 63677 8 
#> metadata(2): '' version
#> assays(4): counts mu H cooks
#> rownames(63677): ENSG00000000003 ENSG00000000005 ... ENSG00000273492
#>   ENSG00000273493
#> rowData names(62): gene_id gene_name ... cell_controlled_pvalue
#>   cell_controlled_padj
#> colnames(8): SRR1039508 SRR1039509 ... SRR1039520 SRR1039521
#> colData names(10): SampleName cell ... BioSample sizeFactor
#> reducedDimNames(0):
#> mainExpName: NULL
#> altExpNames(0):
#> dea(2): baseline, cell_controlled 
#> fea(4): baseline_up_go, baseline_down_go, cell_controlled_up_go, cell_controlled_down_go
```

With the enrichments added, we can now call our shiny app for
exploration! (Note: this is a work in progress, I still need to figure
out how to properly show this in the vignette)

``` r
app <- exploreSE()
if(interactive()){
  shiny::runApp(app, port = 1234)
}
```

#' DE results for airway - baseline
#'
#' Example DE results for airway data set
#'
#' @details
#' This is a `DESEqResults` object, with the simplest model, using `~dex` as
#' the design. Data is from the airway package, DE results are generated with `DESeq2`.
#'
#' @return A DESEqResults
#'
#' @format A DESEqResults
#'
#' @name baseline
#' @docType data
NULL

#' DE results for airway - cell-controlled
#'
#' Example DE results for airway data set
#'
#' @details
#' This is a `DESEqResults` object, using `~ cell + dex` as the design.
#' Data is from the airway package, DE results are generated with `DESeq2`,
#' using the `dex untrt vs trt` contrast
#'
#' @return A DESEqResults
#'
#' @format A DESEqResults
#'
#' @name cell_controlled
#' @docType data
NULL


#' Example GO enrichments for the baseline model
#'
#' GO enrichments based on the `baseline` DE results
#' @details
#'
#' GO enrichmens are generated with `clusterProfiler`, filtered on up-regulated
#' genes only; genes that underwent DE testing were taken as the universe.
#'
#'
#' The code to create said object can be found in the folder `/inst/scripts` in
#' the exploreSE package, the file is called `creating_dataset_examples.R`.
#'
#' @return A EnrichResults object
#'
#' @format A EnrichResults
#'
#' @name baseline_up_go
#' @docType data
NULL


#' Example GO enrichments for the baseline model
#'
#' GO enrichments based on the `baseline` DE results
#' @details
#'
#' GO enrichmens are generated with `clusterProfiler`, filtered on down-regulated
#' genes only; genes that underwent DE testing were taken as the universe.
#'
#' The code to create said object can be found in the folder `/inst/scripts` in
#' the exploreSE package, the file is called `creating_dataset_examples.R`.
#'
#' @return A EnrichResults object
#'
#' @format A EnrichResults
#'
#' @name baseline_down_go
#' @docType data
NULL


#' Example GO enrichments for the cell controlled model
#'
#' GO enrichments based on the `cell_controlled` DE results
#' @details
#'
#' GO enrichmens are generated with `clusterProfiler`, filtered on up-regulated
#' genes only; genes that underwent DE testing were taken as the universe.
#'
#' The code to create said object can be found in the folder `/inst/scripts` in
#' the exploreSE package, the file is called `creating_dataset_examples.R`.
#'
#' @return A EnrichResults object
#'
#' @format A EnrichResults
#'
#' @name controlled_up_go
#' @docType data
NULL


#' Example GO enrichments for the cell_controlled model
#'
#' GO enrichments based on the `cell_controlled` DE results
#' @details
#'
#' GO enrichmens are generated with `clusterProfiler`, filtered on down-regulated
#' genes only; genes that underwent DE testing were taken as the universe.
#'
#' The code to create said object can be found in the folder `/inst/scripts` in
#' the exploreSE package, the file is called `creating_dataset_examples.R`.
#'
#' @return A EnrichResults object
#'
#' @format A EnrichResults
#'
#' @name controlled_down_go
#' @docType data
NULL

library(DESeq2)
library(DeeDeeExperiment)
library(airway)

data(airway)

airway <- airway[rowData(airway)$gene_biotype == "protein_coding", ]

airway <- DESeqDataSet(airway, design = ~dex)
airway <- DESeq(airway)
baseline <- results(airway)

design(airway) <- ~ cell + dex
airway <- DESeq(airway)
cell_controlled <- results(airway)

universe_baseline <- baseline %>%
  BiocGenerics::as.data.frame() %>%
  tibble::rownames_to_column("gene") %>%
  dplyr::filter(!is.na(padj)) %>%
  dplyr::pull(gene)

up_baseline <- baseline %>%
  BiocGenerics::as.data.frame() %>%
  tibble::rownames_to_column("gene") %>%
  dplyr::filter(padj < 0.05, log2FoldChange > 1) %>%
  dplyr::pull(gene)
dn_baseline <- baseline %>%
  BiocGenerics::as.data.frame() %>%
  tibble::rownames_to_column("gene") %>%
  dplyr::filter(padj < 0.05, log2FoldChange < -1) %>%
  dplyr::pull(gene)


baseline_up_go <- clusterProfiler::enrichGO(
  up_baseline,
  org.Hs.eg.db::org.Hs.eg.db,
  keyType = "ENSEMBL",
  ont = "BP",
  universe = universe_baseline
)


baseline_down_go <- clusterProfiler::enrichGO(
  dn_baseline,
  org.Hs.eg.db::org.Hs.eg.db,
  keyType = "ENSEMBL",
  ont = "BP",
  universe = universe_baseline
)


universe_controlled <- cell_controlled %>%
  BiocGenerics::as.data.frame() %>%
  tibble::rownames_to_column("gene") %>%
  dplyr::filter(!is.na(padj)) %>%
  dplyr::pull(gene)

up_controlled <- cell_controlled %>%
  BiocGenerics::as.data.frame() %>%
  tibble::rownames_to_column("gene") %>%
  dplyr::filter(padj < 0.05, log2FoldChange > 1) %>%
  dplyr::pull(gene)
dn_controlled <- cell_controlled %>%
  BiocGenerics::as.data.frame() %>%
  tibble::rownames_to_column("gene") %>%
  dplyr::filter(padj < 0.05, log2FoldChange < -1) %>%
  dplyr::pull(gene)


controlled_up_go <- clusterProfiler::enrichGO(
  up_controlled,
  org.Hs.eg.db::org.Hs.eg.db,
  keyType = "ENSEMBL",
  ont = "BP",
  universe = universe_controlled
)
controlled_down_go <- clusterProfiler::enrichGO(
  dn_controlled,
  org.Hs.eg.db::org.Hs.eg.db,
  keyType = "ENSEMBL",
  ont = "BP",
  universe = universe_controlled
)
# save(baseline, file = "data/baseline_de.RData", compress = "xz")
# save(cell_controlled, file = "data/controlled_de.RData", compress = "xz")

# save(baseline_up_go, file = "data/baseline_up_go.RData", compress = "xz")
# save(baseline_down_go, file = "data/baseline_down_go.RData", compress = "xz")

# save(controlled_up_go, file = "data/controlled_up_go.RData", compress = "xz")
# save(controlled_down_go, file = "data/controlled_down_go.RData", compress = "xz")

#' checks for the presence of pre-computed DE results in the
#' the object. It checks the DeeDee slot if applicable, otherwise
#' it checks metadata(object)$de_results
#' @noRd
.check_precomputed_de <- function(SE) {
    if (is.null(SE)) {
        return(FALSE)
    }
    if (
        methods::is(SE, "DeeDeeExperiment") &&
            !is.null(DeeDeeExperiment::getDEANames(SE))
    ) {
        return(TRUE)
    } else {
        !is.null(S4Vectors::metadata(SE)$de_results) &&
            is.list(S4Vectors::metadata(SE)$de_results) &&
            length(S4Vectors::metadata(SE)$de_results) > 0
    }
}

#' checks for the presence of pre-computed FE results in the
#' the object. It checks the DeeDee slot if applicable, otherwise
#' it checks metadata(object)$fe_results
#' @noRd
.check_precomputed_fe <- function(SE) {
    if (is.null(SE)) {
        return(FALSE)
    }
    if (
        methods::is(SE, "DeeDeeExperiment") &&
            !is.null(DeeDeeExperiment::getFEANames(SE))
    ) {
        return(TRUE)
    } else {
        !is.null(S4Vectors::metadata(SE)$fe_results) &&
            is.list(S4Vectors::metadata(SE)$fe_results) &&
            length(S4Vectors::metadata(SE)$fe_results) > 0
    }
}

#' helper funciton to fetch the names of the DE comparisons in the object
#' @noRd
.de_results_names <- function(SE) {
    if (methods::is(SE, "DeeDeeExperiment")) {
        DeeDeeExperiment::getDEANames(SE)
    } else {
        names(S4Vectors::metadata(SE)$de_results)
    }
}

#' helper funciton to fetch the names of the FE comparisons in the object,
#' belonging to a specified DE comparison
#' @noRd
.fe_results_names <- function(SE, NAME) {
    if (methods::is(SE, "DeeDeeExperiment")) {
        return(names(DeeDeeExperiment::getFEAList(SE, NAME)))
    }
    return(names(S4Vectors::metadata(SE)$fe_results[[NAME]]))
}

# fetches a specified DE comparison by name
#' @noRd
.de_result <- function(SE, NAME) {
    if (methods::is(SE, "DeeDeeExperiment")) {
        res <- DeeDeeExperiment::getDEA(SE, NAME, type = "data.frame") %>%
            dplyr::rename_with(.fn = \(x) {
                stringr::str_remove(x, paste0(NAME, "_"))
            })
    } else {
        res <- S4Vectors::metadata(SE)$de_results[[NAME]]
    }
}

# fetches a specified DE comparison by name
#' @noRd
.fe_result <- function(SE, NAME) {
    fe_list <- DeeDeeExperiment::getFEAList(SE, NAME, format = "original") %>%
        purrr::map(BiocGenerics::as.data.frame)
    return(fe_list)
}

# plotting function for DE genes, returns a bar chart
#' @noRd
.plot_des <- function(
    RES,
    NAME,
    padj_CO = 0.05,
    fc_CO = 1,
    COLS = c("darkred", "darkblue")
) {
    p <- RES %>%
        dplyr::filter(padj < padj_CO, abs(fc_CO) >= 1) %>%
        dplyr::mutate(
            direction = ifelse(log2FoldChange > fc_CO, "Up", "Down")
        ) %>%
        dplyr::count(direction) %>%
        ggplot2::ggplot(ggplot2::aes(direction, y = n, fill = direction)) +
        ggplot2::geom_col() +
        ggplot2::geom_label(
            ggplot2::aes(label = n),
            fill = "white",
            show.legend = FALSE
        ) +
        ggplot2::scale_fill_manual(values = COLS) +
        ggplot2::labs(title = paste("DE genes in", NAME), ) +
        ggplot2::theme_light(base_size = 14) +
        ggplot2::theme(legend.position = "none")
    return(p)
}
#' takes the functional enrichments and creates a bar chart
#' recognises GSEA results  by the use of NES in the colnames
#' for ORA analyiss it plots the Fold Enrichment when available or
#' able to be calculated
#' @noRd
.plot_fe <- function(
    FE,
    NAME = "up_go",
    padj_CO = 0.05,
    N_terms = 5,
    COLS = c("Up" = "darkred", "Down" = "blue")
) {
    # this can probably go when the DeeDee devel branch hits main, but for now needs to stay
    padj_col <- ifelse("gs_p.adjust" %in% names(FE), "gs_p.adjust", "p.adjust")

    if (sum(stringr::str_detect(names(FE), "NES")) > 0) {
        gsea_df <- FE %>%
            dplyr::filter(!!rlang::sym(padj_col) < padj_CO) %>%
            dplyr::group_by(sign(NES)) %>%
            dplyr::slice_max(abs(NES), n = round(N_terms / 2)) %>%
            dplyr::ungroup() %>%
            dplyr::mutate(
                Description = stringr::str_remove(Description, "HALLMARK_") %>%
                    stringr::str_remove("REACTOME") %>%
                    stringr::str_replace_all("_", " ") %>%
                    forcats::fct_reorder(NES),
                dir = ifelse(NES > 0, "Up", "Down")
            )

        p <- ggplot2::ggplot(gsea_df, ggplot2::aes(NES, Description)) +
            ggplot2::geom_col(ggplot2::aes(fill = dir)) +
            ggplot2::scale_y_discrete(labels = \(x) {
                stringr::str_wrap(x, width = 60)
            }) +
            ggplot2::scale_fill_manual(values = COLS) +
            ggplot2::theme_light(base_size = 14) +
            ggplot2::labs(
                x = "NES (Normalized Enrichment Score)",
                title = if (stringr::str_detect(NAME, "HALLMARK")) {
                    paste("Top", N_terms, "enriched hallmark gene sets")
                } else {
                    paste("Top", N_terms, "enriched Reactome gene sets")
                }
            ) +
            ggplot2::theme(
                axis.title.y = ggplot2::element_blank(),
                legend.position = "none"
            )
    } else {
        # this can probably go, when the DeeDee devel branch hits main, but for now needs to stay
        filter_col <- dplyr::case_when(
            "FoldEnrichment" %in% names(FE) ~ "FoldEnrichment",
            "GeneRatio" %in%
                names(FE) &
                "BgRatio" %in% names(FE) ~ "FoldEnrichment",
            "gs_p.adjust" %in% names(FE) ~ "gs_p.adjust",
            TRUE ~ "p.adjust"
        )

        if (
            filter_col == "FoldEnrichment" & !("FoldEnrichment" %in% names(FE))
        ) {
            FE <- FE %>%
                dplyr::rowwise() %>%
                dplyr::mutate(
                    GR = stringr::str_split(GeneRatio, "/") %>%
                        unlist() %>%
                        as.numeric() %>%
                        (\(x) x[[1]] / x[[2]]),
                    BR = stringr::str_split(BgRatio, "/") %>%
                        unlist() %>%
                        as.numeric() %>%
                        (\(x) x[[1]] / x[[2]])
                ) %>%
                dplyr::ungroup() %>%
                dplyr::mutate(FoldEnrichment = GR / BR) %>%
                dplyr::select(-GR, -BR)
        }

        if (filter_col == "FoldEnrichment") {
            df <- FE %>%
                dplyr::filter(!!rlang::sym(padj_col) < padj_CO) %>%
                dplyr::slice_max(FoldEnrichment, n = N_terms) %>%
                dplyr::mutate(
                    Description = forcats::fct_reorder(
                        Description,
                        FoldEnrichment
                    ),
                    dir = ifelse(
                        stringr::str_detect(NAME, "[Uu][Pp]"),
                        "Up",
                        "Down"
                    )
                )
            p <- ggplot2::ggplot(
                df,
                ggplot2::aes(
                    FoldEnrichment,
                    Description,
                    text = stringr::str_wrap(
                        stringr::str_replace_all(geneID, "\\/", ", "),
                        width = 60
                    )
                )
            ) +
                ggplot2::geom_col(ggplot2::aes(fill = dir)) +
                ggplot2::scale_y_discrete(labels = \(x) {
                    stringr::str_wrap(x, width = 60)
                }) +
                ggplot2::scale_fill_manual(values = COLS) +
                ggplot2::theme_light(base_size = 14) +
                ggplot2::labs(
                    x = "Fold Enrichment over Background",
                    title = if (stringr::str_detect(NAME, "up")) {
                        paste("Top", N_terms, "upregulated GO Terms")
                    } else {
                        paste("Top", N_terms, "downregulated GO Terms")
                    }
                ) +
                ggplot2::theme(
                    axis.title.y = ggplot2::element_blank(),
                    legend.position = "none"
                )
        } else {
            df <- FE %>%
                dplyr::filter(!!rlang::sym(padj_col) < padj_CO) %>%
                dplyr::slice_min(!!rlang::sym(filter_col), n = N_terms) %>%
                dplyr::mutate(
                    padj = -log10(!!rlang::sym(filter_col)),
                    Description = forcats::fct_reorder(Description, padj),
                    dir = ifelse(
                        stringr::str_detect(NAME, "[Uu][Pp]"),
                        "Up",
                        "Down"
                    )
                )
            p <- ggplot2::ggplot(
                df,
                ggplot2::aes(
                    padj,
                    Description,
                    text = stringr::str_wrap(
                        stringr::str_replace_all(geneID, "\\/", ", "),
                        width = 60
                    )
                )
            ) +
                ggplot2::geom_col(ggplot2::aes(fill = dir)) +
                ggplot2::scale_y_discrete(labels = \(x) {
                    stringr::str_wrap(x, width = 60)
                }) +
                ggplot2::scale_fill_manual(values = COLS) +
                ggplot2::theme_light(base_size = 14) +
                ggplot2::labs(
                    x = "-log10 adjusted p-Value",
                    title = if (stringr::str_detect(NAME, "[Uu][Pp]")) {
                        paste("Top", N_terms, "upregulated GO Terms")
                    } else {
                        paste("Top", N_terms, "downregulated GO Terms")
                    }
                ) +
                ggplot2::theme(
                    axis.title.y = ggplot2::element_blank(),
                    legend.position = "none"
                )
        }
    }
    p_p <- plotly::ggplotly(p, tooltip = c("text")) %>%
        plotly::layout(hovermode = "closest") %>%
        plotly::style(textposition = "right")
    return(p_p)
}
#' plots a volcano plot, highlights selected genes.
#' @noRd
.plot_volcano <- function(
    RES,
    NAME,
    padj_CO = 0.05,
    fc_CO = 1,
    highlights = NULL,
    COLS,
    LABEL_TOP = TRUE,
    TOPN = 5,
    gene_var = "gene_id"
) {
    gene_var <- rlang::sym(gene_var)
    # Prep data
    volcano_df <- RES %>%
        dplyr::filter(
            !is.na(padj) & !is.na(log2FoldChange) & !is.infinite(log2FoldChange)
        ) %>%
        dplyr::mutate(gene_id = !!gene_var) %>%
        dplyr::mutate(
            highlighted = gene_id %in% highlights,
            sig = dplyr::case_when(
                padj < padj_CO & log2FoldChange > fc_CO ~ "Up",
                padj < padj_CO & log2FoldChange < -fc_CO ~ "Down",
                TRUE ~ "NS"
            )
        ) %>%
        dplyr::mutate(
            display_category = dplyr::case_when(
                highlighted ~ "Highlighted",
                TRUE ~ sig
            )
        )

    # Identify top genes
    genes_to_label <- data.frame()
    if (LABEL_TOP && TOPN > 0) {
        top_genes <- volcano_df %>%
            dplyr::filter(sig != "NS" & !highlighted) %>%
            dplyr::slice_min(padj, n = TOPN)
        genes_to_label <- rbind(genes_to_label, top_genes)
    }

    # highlighted genes
    if (length(highlights) > 0) {
        highlighted_genes <- volcano_df %>%
            dplyr::filter(highlighted)
        genes_to_label <- rbind(genes_to_label, highlighted_genes)
    }

    # Reorder for plotly
    volcano_df <- volcano_df %>%
        dplyr::arrange(highlighted)

    #  plot
    p <- ggplot2::ggplot(
        volcano_df,
        ggplot2::aes(
            x = log2FoldChange,
            y = -log10(padj),
            color = display_category,
            text = paste(
                "log2 FC:",
                round(log2FoldChange, 2),
                "\nGene:",
                gene_id,
                "\nadjusted p-value:",
                format(padj, digits = 4)
            )
        )
    ) +
        ggplot2::geom_point(ggplot2::aes(
            size = highlighted,
            alpha = ifelse(highlighted, 1, 0.6)
        )) +
        ggplot2::scale_size_manual(
            values = c("TRUE" = 3, "FALSE" = 1.5),
            guide = "none"
        ) +
        ggplot2::scale_alpha_identity() +
        ggplot2::scale_color_manual(
            values = COLS,
            name = "Category",
            breaks = c("Up", "Down", "Highlighted", "NS"),
            labels = c(
                "Up-regulated",
                "Down-regulated",
                "Highlighted",
                "Not significant"
            )
        ) +
        ggplot2::geom_vline(
            xintercept = c(-fc_CO, fc_CO),
            linetype = "dashed",
            color = "grey30",
            linewidth = 0.5
        ) +
        ggplot2::geom_hline(
            yintercept = -log10(padj_CO),
            linetype = "dashed",
            color = "grey30",
            linewidth = 0.5
        ) +
        ggplot2::labs(
            x = "Log2 Fold Change",
            y = "-Log10 Adjusted P-value",
            title = if (!is.null(NAME)) {
                paste("Volcano Plot:", NAME)
            } else {
                "Volcano Plot"
            }
        ) +
        ggplot2::theme_minimal(base_size = 14) +
        ggplot2::theme(
            legend.position = "right",
            panel.grid.minor = ggplot2::element_blank()
        )

    # Add labels
    if (nrow(genes_to_label) > 0) {
        p <- p +
            ggplot2::geom_text(
                data = genes_to_label,
                ggplot2::aes(label = gene_id),
                size = 5,
                show.legend = FALSE
            )
    }

    p_p <- plotly::ggplotly(p, tooltip = c("text")) %>%
        plotly::layout(hovermode = "closest") %>%
        plotly::style(textposition = "right")

    return(p_p)
}

#' creates the expression plot; still needs work re: normalisation of counts
#' @noRd
.plot_expression <- function(SE, GENE, BY, LEVELS, PLOT_TYPE, GENE_VAR) {
    # get the right row to plot
    gene <- rownames(SummarizedExperiment::rowData(SE)[
        which(
            SummarizedExperiment::rowData(SE)[, GENE_VAR] == GENE
        ),
    ])[1]

    if ("counts" %notin% SummarizedExperiment::assayNames(SE)) {
        message("counts not found in assays, defaulting to first assay")
        counts_data <- SummarizedExperiment::assay(SE)[[1]][gene, ]
    } else if ("sizeFactor" %in% names(SummarizedExperiment::colData(SE))) {
        counts_data <- SummarizedExperiment::assay(SE, "counts")
        sf <- SummarizedExperiment::colData(SE)[, "sizeFactor"]
        counts_data <- sweep(counts_data, 2, sf, "/")[gene, ]
    } else {
        counts_data <- SummarizedExperiment::assay(SE, "counts")[gene, ]
    }

    plot_df <- data.frame(
        s_a_m_p_l_e = colnames(SE),
        expression = counts_data,
        group = forcats::as_factor(SummarizedExperiment::colData(SE)[[
            BY
        ]])
    ) %>%
        dplyr::filter(group %in% LEVELS)

    p <- ggplot2::ggplot(
        plot_df,
        ggplot2::aes(
            x = group,
            y = expression,
            fill = group,
            text = s_a_m_p_l_e
        )
    ) +
        ggplot2::labs(
            title = paste("Expression:", GENE),
            x = BY,
            y = "Counts"
        ) +
        ggplot2::scale_x_discrete(labels = \(x) {
            stringr::str_wrap(stringr::str_replace_all(x, "_", " "), 10)
        }) +
        ggplot2::theme_minimal(base_size = 14) +
        ggplot2::theme(legend.position = "none")

    if (PLOT_TYPE == "violin" && any(table(droplevels(plot_df$group)) < 2)) {
        # group size check
        shiny::showNotification(
            "Some selected groups have fewer than two samples; showing a box plot instead of violin.",
            type = "warning"
        )
        PLOT_TYPE <- "box"
    }

    if (PLOT_TYPE == "box") {
        p <- p +
            ggplot2::geom_boxplot(alpha = 0.7) +
            ggplot2::geom_jitter(width = 0.2, alpha = 0.5, size = 2)
    } else {
        # removing the text geom from violin, cant handle it
        p <- p +
            ggplot2::geom_violin(ggplot2::aes(text = NULL), alpha = 0.7) +
            ggplot2::geom_jitter(width = 0.1, alpha = 0.5, size = 2)
    }
}


#' Creates some random data tio demonstrate the colData, PCA and expression elements.
#' @noRd
.create_demo_data <- function() {
    n_genes <- 1000
    n_samples <- 12

    # Simulate count data
    counts <- matrix(
        stats::rnbinom(n_genes * n_samples, mu = 100, size = 1 / 0.5),
        nrow = n_genes
    )
    rownames(counts) <- paste0("GENE", seq_len(n_genes))
    colnames(counts) <- paste0("Sample", seq_len(n_samples))

    # Add some differential expression
    de_genes <- seq_len(100)
    counts[de_genes, seq_len(6)] <- counts[de_genes, seq_len(6)] * 3

    # Sample metadata
    colData <- S4Vectors::DataFrame(
        condition = factor(rep(c("Control", "Treatment"), each = 6)),
        batch = factor(rep(c("A", "B"), times = 6)),
        replicate = rep(seq_len(6), times = 2)
    )
    rownames(colData) <- colnames(counts)

    # Gene metadata
    rowData <- S4Vectors::DataFrame(
        gene_id = rownames(counts),
        gene_name = paste0("Gene_", seq_len(n_genes))
    )

    SummarizedExperiment::SummarizedExperiment(
        assays = list(counts = counts),
        colData = colData,
        rowData = rowData
    )
}

#' creates fc-fc plots
#' @noRd
.plot_fcfc <- function(
    OBJ,
    NAME,
    PARTNER_NAME,
    GENE_VAR = "SYMBOL",
    GENE_VARS = c("SYMBOL"),
    padj_CO = 0.05,
    fc_CO = 1,
    COLS = rev(c("red", "blue", "purple", "grey")),
    LABEL_TOP = TRUE,
    TOPN = 5
) {
    COLS <- COLS |>
        purrr::set_names(c(NAME, PARTNER_NAME, "ns", "both"))
    gene_var <- rlang::sym(GENE_VAR)

    df_a <- .de_result(OBJ, NAME = NAME) |>
        tibble::rownames_to_column("gene_ident")

    df_b <- .de_result(OBJ, NAME = PARTNER_NAME) |>
        tibble::rownames_to_column("gene_ident")

    df_list <- list(df_a, df_b) |>
        purrr::set_names(c(NAME, PARTNER_NAME)) |>
        purrr::map(\(x) {
            dplyr::filter(
                x,
                !is.na(padj),
                !is.na(log2FoldChange),
                !is.infinite(log2FoldChange)
            )
        }) |>
        purrr::imap(\(DF, .NAME) {
            dplyr::mutate(
                DF,
                sig = ifelse(
                    padj < padj_CO & abs(log2FoldChange) > fc_CO,
                    .NAME,
                    "ns"
                )
            )
        })

    df_comb <- dplyr::left_join(
        df_list[[NAME]],
        df_list[[PARTNER_NAME]],
        by = dplyr::join_by(gene_ident),
        suffix = paste0("_", c("A", "B"))
    ) |>
        dplyr::mutate(
            sig = dplyr::case_when(
                sig_A == "ns" & sig_B == "ns" ~ "ns",
                sig_A == NAME & sig_B == PARTNER_NAME ~ "both",
                sig_A == "ns" ~ PARTNER_NAME,
                sig_B == "ns" ~ NAME
            ) |>
                forcats::fct_relevel("ns", "both", PARTNER_NAME)
        ) |>
        dplyr::select(-sig_A, -sig_B) |>
        dplyr::filter(!is.na(sig))

    merging_data <- SummarizedExperiment::rowData(OBJ) |>
        as.data.frame() |>
        dplyr::select(tidyselect::any_of(GENE_VARS)) |>
        tibble::rownames_to_column("gene_ident")

    df_comb <- merging_data |>
        dplyr::inner_join(df_comb, by = dplyr::join_by(gene_ident)) |>
        dplyr::mutate(gene_id = !!gene_var)

    p <- ggplot2::ggplot(
        df_comb,
        ggplot2::aes(
            log2FoldChange_A,
            log2FoldChange_B,
            color = sig,
            text = paste(
                "Gene:",
                gene_id,
                "\n",
                paste("logFC", NAME),
                round(log2FoldChange_A, 2),
                "\n",
                paste("logFC", PARTNER_NAME),
                round(log2FoldChange_B, 2)
            )
        )
    ) +
        ggplot2::geom_point() +
        ggplot2::scale_color_manual(values = COLS) +
        ggplot2::labs(
            x = paste("logFC", NAME),
            y = paste("logFC", PARTNER_NAME),
            color = "Signficant in:"
        ) +
        ggplot2::theme_minimal(base_size = 14)

    p <- plotly::ggplotly(p, tooltip = c("text"))
    return(p)
}

## Tests for the DeeDeeExperiment code path of the explorer_utils.R helpers.
## clusterProfiler/DeeDeeExperiment internals aren't exercised here - mock
## the getDEA*/getFEA* accessors to keep the tests fast and focused
## on the logic in explorer_utils.R itself.
se_de <- se_with_de

make_empty_dde <- function() {
  se <- SummarizedExperiment::SummarizedExperiment(
    assays = list(
      counts = matrix(
        1:4,
        nrow = 2,
        dimnames = list(c("g1", "g2"), c("s1", "s2"))
      )
    )
  )
  DeeDeeExperiment::DeeDeeExperiment(se)
}

test_that(".check_precomputed_de is FALSE for a DeeDeeExperiment with no DEA results", {
  expect_false(.check_precomputed_de(make_empty_dde()))
})

test_that(".check_precomputed_de is TRUE when getDEANames() reports results", {
  testthat::local_mocked_bindings(
    getDEANames = function(...) c("comparisonA"),
    .package = "DeeDeeExperiment"
  )
  expect_true(.check_precomputed_de(se_de))
})

test_that(".check_precomputed_fe is FALSE for a DeeDeeExperiment with no FEA results", {
  expect_false(.check_precomputed_fe(make_empty_dde()))
})

test_that(".check_precomputed_fe is TRUE when getFEANames() reports results", {
  testthat::local_mocked_bindings(
    getFEANames = function(...) c("comparisonA_up_go"),
    .package = "DeeDeeExperiment"
  )
  expect_true(.check_precomputed_fe(se_de))
})

test_that(".de_results_names delegates to getDEANames() for a DeeDeeExperiment", {
  testthat::local_mocked_bindings(
    getDEANames = function(...) c("comparisonA", "comparisonB"),
    .package = "DeeDeeExperiment"
  )
  expect_equal(.de_results_names(se_de), c("comparisonA", "comparisonB"))
})

test_that(".fe_results_names delegates to names(getFEAList()) for a DeeDeeExperiment", {
  testthat::local_mocked_bindings(
    getFEAList = function(...) list(up_go = data.frame(), dn_go = data.frame()),
    .package = "DeeDeeExperiment"
  )
  expect_equal(.fe_results_names(se_de, "comparisonA"), c("up_go", "dn_go"))
})

test_that(".de_result strips the 'NAME_' column prefix returned by getDEA()", {
  fake_res <- data.frame(
    comparisonA_padj = c(0.01, 0.2),
    comparisonA_log2FoldChange = c(2, -0.5)
  )
  testthat::local_mocked_bindings(
    getDEA = function(...) fake_res,
    .package = "DeeDeeExperiment"
  )

  result <- .de_result(se_de, "comparisonA")

  expect_named(result, c("padj", "log2FoldChange"))
  expect_equal(result$padj, c(0.01, 0.2))
  expect_equal(result$log2FoldChange, c(2, -0.5))
})

test_that(".de_result only strips the matching NAME prefix, not unrelated columns", {
  fake_res <- data.frame(
    comparisonA_padj = 0.01,
    unrelated_column = "kept as-is"
  )
  testthat::local_mocked_bindings(
    getDEA = function(...) fake_res,
    .package = "DeeDeeExperiment"
  )

  result <- .de_result(se_de, "comparisonA")

  expect_named(result, c("padj", "unrelated_column"))
})

test_that(".de_result works unmocked against se_de's real getDEA() output", {
  result <- .de_result(se_de, "baseline")

  expect_named(result, c("log2FoldChange", "pvalue", "padj"))
  expect_equal(nrow(result), nrow(se_de))
})

test_that(".fe_result converts every entry of the FEA list to a data frame", {
  fake_fea <- list(
    up_go = data.frame(Description = "term A", p.adjust = 0.01),
    dn_go = data.frame(Description = "term B", p.adjust = 0.02)
  )
  testthat::local_mocked_bindings(
    getFEAList = function(...) fake_fea,
    .package = "DeeDeeExperiment"
  )

  result <- .fe_result(se_de, "comparisonA")

  expect_named(result, c("up_go", "dn_go"))
  expect_true(all(vapply(result, is.data.frame, logical(1))))
  expect_equal(result$up_go$Description, "term A")
})

test_that(".fe_result works unmocked against se_with_go's real getFEAList() output", {
  data("se_with_gos", package = "exploreSE")

  result <- .fe_result(se_with_go, "baseline")

  expect_named(result, c("baseline_up_go", "baseline_down_go"))
  expect_true(all(vapply(result, is.data.frame, logical(1))))
  expect_true(all(vapply(
    result,
    function(x) "FoldEnrichment" %in% names(x),
    logical(1)
  )))
})

test_that(".create_demo_data returns a well-formed SummarizedExperiment", {
  se <- .create_demo_data()

  expect_s4_class(se, "SummarizedExperiment")
  expect_equal(dim(se), c(1000, 12))
  expect_true("counts" %in% SummarizedExperiment::assayNames(se))
})

test_that(".create_demo_data counts are non-negative integers with the expected dimnames", {
  se <- .create_demo_data()
  counts <- SummarizedExperiment::assay(se, "counts")

  expect_true(all(counts >= 0))
  expect_equal(counts, round(counts))
  expect_equal(rownames(counts), paste0("GENE", seq_len(1000)))
  expect_equal(colnames(counts), paste0("Sample", seq_len(12)))
})

test_that(".create_demo_data sets up condition/batch/replicate colData", {
  se <- .create_demo_data()
  cd <- SummarizedExperiment::colData(se)

  expect_equal(colnames(cd), c("condition", "batch", "replicate"))
  expect_equal(as.character(cd$condition), rep(c("Control", "Treatment"), each = 6))
  expect_equal(as.character(cd$batch), rep(c("A", "B"), times = 6))
  expect_equal(cd$replicate, rep(seq_len(6), times = 2))
})

test_that(".create_demo_data sets up gene_id/gene_name rowData", {
  se <- .create_demo_data()
  rd <- SummarizedExperiment::rowData(se)

  expect_equal(rd$gene_id, rownames(se))
  expect_equal(rd$gene_name, paste0("Gene_", seq_len(1000)))
})

## Tests for .plot_expression and .plot_fcfc

se_de <- se_with_de

test_that(".plot_expression returns a ggplot titled with the gene name", {
  p <- .plot_expression(
    se_de,
    GENE = "TSPAN6",
    BY = "dex",
    LEVELS = c("trt", "untrt"),
    PLOT_TYPE = "box",
    GENE_VAR = "symbol"
  )

  expect_s3_class(p, "ggplot")
  expect_equal(p$labels$title, "Expression: TSPAN6")
  expect_equal(p$labels$x, "dex")
  expect_equal(p$labels$y, "Counts")
})

test_that(".plot_expression uses boxplot vs violin geoms depending on PLOT_TYPE", {
  p_box <- .plot_expression(
    se_de,
    GENE = "TSPAN6",
    BY = "dex",
    LEVELS = c("trt", "untrt"),
    PLOT_TYPE = "box",
    GENE_VAR = "symbol"
  )
  p_violin <- .plot_expression(
    se_de,
    GENE = "TSPAN6",
    BY = "dex",
    LEVELS = c("trt", "untrt"),
    PLOT_TYPE = "violin",
    GENE_VAR = "symbol"
  )

  box_geoms <- sapply(p_box$layers, function(l) class(l$geom)[1])
  violin_geoms <- sapply(p_violin$layers, function(l) class(l$geom)[1])

  expect_true("GeomBoxplot" %in% box_geoms)
  expect_true("GeomViolin" %in% violin_geoms)
})

test_that(".plot_expression normalises counts by sizeFactor when present", {
  gene <- rownames(SummarizedExperiment::rowData(se_de)[
    which(SummarizedExperiment::rowData(se_de)[, "symbol"] == "TSPAN6"),
  ])[1]

  raw_counts <- SummarizedExperiment::assay(se_de, "counts")[gene, ]
  sf <- SummarizedExperiment::colData(se_de)[, "sizeFactor"]
  expected <- unname(raw_counts / sf)

  p <- .plot_expression(
    se_de,
    GENE = "TSPAN6",
    BY = "dex",
    LEVELS = c("trt", "untrt"),
    PLOT_TYPE = "box",
    GENE_VAR = "symbol"
  )
  built <- ggplot2::ggplot_build(p)$data[[1]]
  plotted <- built$y[match(colnames(se_de), built$text)]

  expect_equal(plotted, expected, tolerance = 1e-6)
})

test_that(".plot_expression filters samples down to the requested LEVELS", {
  p <- .plot_expression(
    se_de,
    GENE = "TSPAN6",
    BY = "dex",
    LEVELS = "trt",
    PLOT_TYPE = "box",
    GENE_VAR = "symbol"
  )
  built <- ggplot2::ggplot_build(p)$data[[1]]

  expect_equal(
    nrow(built),
    sum(SummarizedExperiment::colData(se_de)$dex == "trt")
  )
})

test_that(".plot_fcfc returns a plotly comparing two DE comparisons", {
  p <- .plot_fcfc(
    se_de,
    NAME = "baseline",
    PARTNER_NAME = "cell_controlled",
    GENE_VAR = "symbol",
    GENE_VARS = c("symbol")
  )

  expect_s3_class(p, "plotly")
  expect_equal(p$x$layout$xaxis$title$text, "logFC baseline")
  expect_equal(p$x$layout$yaxis$title$text, "logFC cell_controlled")
})

test_that(".plot_fcfc buckets genes into ns/both/NAME/PARTNER_NAME significance groups", {
  p <- .plot_fcfc(
    se_de,
    NAME = "baseline",
    PARTNER_NAME = "cell_controlled",
    GENE_VAR = "symbol",
    GENE_VARS = c("symbol")
  )
  trace_names <- vapply(p$x$data, function(d) d$name, character(1))

  expect_setequal(trace_names, c("ns", "both", "baseline", "cell_controlled"))
})

test_that(".plot_fcfc labels hover text with the gene identifier from GENE_VAR", {
  p <- .plot_fcfc(
    se_de,
    NAME = "baseline",
    PARTNER_NAME = "cell_controlled",
    GENE_VAR = "symbol",
    GENE_VARS = c("symbol")
  )
  all_text <- unlist(lapply(p$x$data, `[[`, "text"))

  expect_true(any(grepl("Gene: TSPAN6", all_text, fixed = TRUE)))
})

## Tests for the ggplot2/plotly building helpers in explorer_utils.R.

de_results <- function(NAME = "baseline") {
  .de_result(se_with_de, NAME) %>%
    tibble::rownames_to_column("gene_id")
}

go_fe_results <- function(NAME = "baseline", direction = "up_go") {
  fe <- .fe_result(se_with_go, NAME)
  fe[[paste0(NAME, "_", direction)]]
}

make_gsea_fe_results <- function() {
  data.frame(
    Description = paste0("HALLMARK_TERM_", 1:10),
    p.adjust = stats::runif(10, 0, 0.1),
    NES = stats::rnorm(10, 0, 2)
  )
}

test_that(".plot_des returns a ggplot summarising up/down gene counts", {
  p <- .plot_des(de_results("baseline"), "baseline")

  expect_s3_class(p, "ggplot")
  expect_equal(p$labels$title, "DE genes in baseline")
})

test_that(".plot_fe handles GO-style (FoldEnrichment) results", {
  p <- .plot_fe(go_fe_results("baseline", "up_go"), NAME = "up_go")
  expect_s3_class(p, "plotly")
})

test_that(".plot_fe handles GSEA-style (NES) results without erroring", {
  p <- .plot_fe(make_gsea_fe_results(), NAME = "comparisonA_gsea_HALLMARK")
  expect_s3_class(p, "plotly")
})

test_that(".plot_fe titles GSEA plots based on HALLMARK vs Reactome in NAME", {
  hallmark_df <- make_gsea_fe_results()
  reactome_df <- make_gsea_fe_results()

  p_hallmark <- .plot_fe(hallmark_df, NAME = "comparisonA_gsea_HALLMARK")
  p_reactome <- .plot_fe(reactome_df, NAME = "comparisonA_gsea_REACTOME")

  expect_s3_class(p_hallmark, "plotly")
  expect_s3_class(p_reactome, "plotly")
})

test_that(".plot_volcano returns a plotly object with LABEL_TOP = TRUE (default)", {
  p <- .plot_volcano(
    de_results("baseline"),
    "baseline",
    COLS = c(Up = "red", Down = "blue", Highlighted = "green", NS = "grey")
  )
  expect_s3_class(p, "plotly")
})

test_that(".plot_volcano returns a plotly object with LABEL_TOP = FALSE", {
  p <- .plot_volcano(
    de_results("baseline"),
    "baseline",
    COLS = c(Up = "red", Down = "blue", Highlighted = "green", NS = "grey"),
    LABEL_TOP = FALSE
  )
  expect_s3_class(p, "plotly")
})

test_that(".plot_volcano works with highlighted genes and no top-N labels", {
  res <- de_results("baseline")
  p <- .plot_volcano(
    res,
    "baseline",
    COLS = c(Up = "red", Down = "blue", Highlighted = "green", NS = "grey"),
    highlights = res$gene_id[1:3],
    LABEL_TOP = FALSE
  )
  expect_s3_class(p, "plotly")
})

test_that(".plot_volcano handles no significant genes gracefully", {
  res <- de_results("baseline") %>%
    dplyr::filter(!is.na(padj), padj > 0.05)
  expect_true(nrow(res) > 0)

  p <- .plot_volcano(
    res,
    "baseline",
    COLS = c(Up = "red", Down = "blue", Highlighted = "green", NS = "grey")
  )
  expect_s3_class(p, "plotly")
})

## Tests for the "plain SummarizedExperiment + metadata()$de_results / $fe_results"

make_se_with_metadata <- function(de_results = NULL, fe_results = NULL) {
  se <- SummarizedExperiment::SummarizedExperiment(
    assays = list(
      counts = matrix(
        1:4,
        nrow = 2,
        dimnames = list(c("g1", "g2"), c("s1", "s2"))
      )
    )
  )
  if (!is.null(de_results)) {
    S4Vectors::metadata(se)$de_results <- de_results
  }
  if (!is.null(fe_results)) {
    S4Vectors::metadata(se)$fe_results <- fe_results
  }
  se
}

test_that(".check_precomputed_de is FALSE for NULL, empty and missing metadata", {
  expect_false(.check_precomputed_de(NULL))
  expect_false(.check_precomputed_de(make_se_with_metadata()))
  expect_false(.check_precomputed_de(make_se_with_metadata(
    de_results = list()
  )))
})

test_that(".check_precomputed_de is TRUE when de_results is a non-empty list", {
  de <- list(comparisonA = data.frame(padj = 0.01, log2FoldChange = 2))
  expect_true(.check_precomputed_de(make_se_with_metadata(de_results = de)))
})

test_that(".check_precomputed_fe is FALSE for NULL, empty and missing metadata", {
  expect_false(.check_precomputed_fe(NULL))
  expect_false(.check_precomputed_fe(make_se_with_metadata()))
  expect_false(.check_precomputed_fe(make_se_with_metadata(
    fe_results = list()
  )))
})

test_that(".check_precomputed_fe is TRUE when fe_results is a non-empty list", {
  fe <- list(comparisonA = list(up_go = data.frame(Description = "term")))
  expect_true(.check_precomputed_fe(make_se_with_metadata(fe_results = fe)))
})

test_that(".de_results_names reads names from metadata$de_results", {
  de <- list(comparisonA = data.frame(), comparisonB = data.frame())
  se <- make_se_with_metadata(de_results = de)
  expect_equal(.de_results_names(se), c("comparisonA", "comparisonB"))
})

test_that(".de_results_names is empty/NULL when no de_results are present", {
  expect_null(.de_results_names(make_se_with_metadata()))
})

test_that(".fe_results_names reads names from metadata$fe_results[[NAME]]", {
  fe <- list(comparisonA = list(up_go = data.frame(), dn_go = data.frame()))
  se <- make_se_with_metadata(fe_results = fe)
  expect_equal(.fe_results_names(se, "comparisonA"), c("up_go", "dn_go"))
})

test_that(".fe_results_names is NULL for an unknown comparison", {
  fe <- list(comparisonA = list(up_go = data.frame()))
  se <- make_se_with_metadata(fe_results = fe)
  expect_null(.fe_results_names(se, "does_not_exist"))
})

test_that(".de_result returns the stored data frame unchanged on the metadata path", {
  res_df <- data.frame(padj = c(0.01, 0.2), log2FoldChange = c(2, -0.5))
  se <- make_se_with_metadata(de_results = list(comparisonA = res_df))

  expect_equal(.de_result(se, "comparisonA"), res_df)
})

#' Calculate GO Enrichments for a given comparison
#'
#' A function to calculate GO term enrichments from a given summarizedExperiment
#' or DeeDee experiment. By default, it calculates separate enrichments for
#' up- downregulated genes, at the cutoffs of |logFC| > 1 and adjusted p-
#' value < 0.05. It utilises the [clusterProfiler::enrichGO()] function.
#'
#' @param NAME character, name of the DE comparison
#' @param obj DeeDeeExperiment or SummarizedExperiment, the object
#' @param species character, the species hs/mm
#' @param gene_type character, the type of gene identifier
#'
#' @returns a DeeDeeExperiment or SummarizedExperiment
#' @export
#'
#' @examples
#'
#' library(airway)
#' library(DeeDeeExperiment)
#' data(airway)
#' data("baseline_de", package = "exploreSE")
#'
#' se_with_de <- addDEA(DeeDeeExperiment(airway), baseline)
#' se_with_go <- get.gos(obj = se_with_de,
#'                       NAME = "baseline",
#'                       gene_type = "ENSEMBL")
#'

get.gos <- function(NAME, obj, species = "hs", gene_type = "SYMBOL") {
  if (species == "hs") {
    DB <- org.Hs.eg.db::org.Hs.eg.db
  } else if (species == "mm") {
    DB <- org.Mm.eg.db::org.Mm.eg.db
  } else {
    stop("Please specify a valid species. Supported: hs, mm")
  }

  if (gene_type %notin% c("SYMBOL", "ENTREZID", "ENSEMBL")) {
    stop(
      "Please specify a valid gene identifier. Supported: SYMBOL, ENSEMBL, ENTREZID"
    )
  }

  res <- .de_result(obj, NAME)

  up_genes <- res %>%
    BiocGenerics::as.data.frame() %>%
    tibble::rownames_to_column("gene") %>%
    dplyr::filter(padj < 0.05, log2FoldChange > 1) %>%
    dplyr::pull(gene)
  dn_genes <- res %>%
    BiocGenerics::as.data.frame() %>%
    tibble::rownames_to_column("gene") %>%
    dplyr::filter(padj < 0.05, log2FoldChange < -1) %>%
    dplyr::pull(gene)

  universe <- res %>%
    BiocGenerics::as.data.frame() %>%
    tibble::rownames_to_column("gene") %>%
    dplyr::filter(!is.na(padj)) %>%
    dplyr::pull(gene)

  up_go <- clusterProfiler::enrichGO(
    up_genes,
    DB,
    keyType = gene_type,
    ont = "BP",
    universe = universe
  ) %>%
    BiocGenerics::as.data.frame()
  dn_go <- clusterProfiler::enrichGO(
    dn_genes,
    DB,
    keyType = gene_type,
    ont = "BP",
    universe = universe
  ) %>%
    BiocGenerics::as.data.frame()

  if (!methods::is(obj, "DeeDeeExperiment")) {
    obj <- DeeDeeExperiment::DeeDeeExperiment(obj)
  }

  if (length(up_genes) > 0) {
    up_go <- clusterProfiler::enrichGO(
      up_genes,
      DB,
      keyType = gene_type,
      ont = "BP",
      universe = universe
    )
    if (!is.null(up_go)) {
      obj <- DeeDeeExperiment::addFEA(obj, up_go, NAME)
      obj <- DeeDeeExperiment::renameFEA(obj, "up_go", paste0(NAME, "_up_go"))
    }
  }

  if (length(dn_genes) > 0) {
    dn_go <- clusterProfiler::enrichGO(
      dn_genes,
      DB,
      keyType = gene_type,
      ont = "BP",
      universe = universe
    )
    if (!is.null(dn_go)) {
      obj <- DeeDeeExperiment::addFEA(obj, dn_go, NAME)
      obj <- DeeDeeExperiment::renameFEA(obj, "dn_go", paste0(NAME, "_down_go"))
    }
  }
  return(obj)
}


#' Calculate GSEA Enrichments for a given comparison
#'
#' Calculates the GSEA enrichments with the counts within a summarizedExperiment
#' or DeeDeeExperiment and adds them in the respective slots. It follows
#' the [original signal-to-noise ratio of the method](https://www.pnas.org/doi/10.1073/pnas.0506580102); other approaches for
#' ranking of genes are available in other implementations,
#' such as the [clusterProfiler::GSEA()] implementation which calls for
#' logFC ranked genes.
#'
#' @param NAME character, name of the DE comparison
#' @param obj DeeDeeExperiment or SummarizedExperiment, the object
#' @param type character, the type of gene set, HALLMARK or REACTOME
#' @param conditions a vector of length 2, which levels of the condition variable are being compared,
#' @param species character, supported values are "hs" and "mm"
#' @param condition_var symbol or character, the variable name for this comparison
#' @param gene_type character, the type of gene identifier
#'
#' @returns a DeeDeeExperiment or SummarizedExperiment
#' @export
#'
#' @examples
#'
#' library(airway)
#' library(DeeDeeExperiment)
#' data(airway)
#' data("baseline_de", package = "exploreSE")
#'
#' se_with_de <- addDEA(DeeDeeExperiment(airway), baseline)
#' se_with_gsea <- get.gsea(NAME = "baseline",
#'                          obj = se_with_de,
#'                          type = "HALLMARK",
#'                          condition_var = "dex",
#'                          conditions = c("trt", "untrt"),
#'                          gene_type = "ENSEMBL")

get.gsea <- function(
  NAME,
  obj,
  type = "HALLMARK",
  conditions,
  species = "hs",
  condition_var = "condition",
  gene_type = "SYMBOL"
) {
  condition_var <- rlang::ensym(condition_var)

  if (species == "hs") {
    SPECIES <- "HS"
  } else if (species == "mm") {
    SPECIES <- "MM"
  } else {
    stop("Please specify a valid species. Supported: hs, mm")
  }

  if (type == "HALLMARK") {
    gene_sets <- msigdbr::msigdbr(collection = "H", db_species = SPECIES)
  } else if (type == "REACTOME") {
    gene_sets <- msigdbr::msigdbr(
      collection = "C2",
      subcollection = "CP:REACTOME",
      db_species = SPECIES
    )
  } else {
    stop(
      "Please specify a valid gene set identifier. Supported: HALLMARK, REACTOME"
    )
  }

  if (gene_type == "SYMBOL") {
    gene_sets <- gene_sets %>%
      dplyr::select(gs_name, gene_symbol) %>%
      dplyr::distinct()
  } else if (gene_type == "ENSEMBL") {
    gene_sets <- gene_sets %>%
      dplyr::select(gs_name, ensembl_gene) %>%
      dplyr::distinct()
  } else if (type == "ENTREZID") {
    gene_sets <- gene_sets %>%
      dplyr::select(gs_name, ncbi_gene) %>%
      dplyr::distinct()
  } else {
    stop(
      "Please specify a valid gene identifier. Supported: SYMBOL, ENSEMBL, ENTREZID"
    )
  }

  cdata <- BiocGenerics::as.data.frame(SummarizedExperiment::colData(obj)) |>
    tibble::rownames_to_column("sample_ident")

  rankings <- BiocGenerics::counts(obj, normalized = TRUE) %>%
    BiocGenerics::as.data.frame() %>%
    tibble::rownames_to_column("gene") %>%
    tidyr::pivot_longer(-gene) %>%
    dplyr::left_join(
      cdata,
      dplyr::join_by(name == sample_ident)
    ) %>%
    dplyr::mutate(condition = !!condition_var) %>%
    dplyr::filter(condition %in% conditions) %>%
    dplyr::select(gene, condition, value) %>%
    dplyr::group_by(condition, gene) %>%
    dplyr::summarise(
      sd = stats::sd(value, na.rm = TRUE),
      mean_expr = mean(value, na.rm = TRUE)
    ) %>%
    dplyr::mutate(
      sd = ifelse(sd >= 0.2 * abs(mean_expr), sd, 0.2 * abs(mean_expr)),
      mean_expr = ifelse(mean_expr == 0, 1, mean_expr)
    ) %>%
    dplyr::mutate(
      condition = ifelse(condition == conditions[2], "group2", "group1")
    ) %>%
    dplyr::select(condition, mean_expr:sd, gene) %>%
    tidyr::pivot_wider(names_from = condition, values_from = mean_expr:sd) %>%
    dplyr::filter(
      dplyr::if_all(sd_group1:sd_group2, \(x) x > 0),
      dplyr::if_any(mean_expr_group1:mean_expr_group2, \(x) x > 0)
    ) %>%
    dplyr::mutate(
      ranking = (mean_expr_group1 - mean_expr_group2) / (sd_group1 + sd_group2),
      gene = forcats::fct_reorder(gene, ranking, .desc = TRUE)
    ) %>%
    dplyr::filter(!is.na(ranking)) %>%
    dplyr::arrange(dplyr::desc(ranking)) %>%
    dplyr::pull(ranking, name = gene)

  gsea <- clusterProfiler::GSEA(rankings, TERM2GENE = gene_sets)

  if (!methods::is(obj, "DeeDeeExperiment")) {
    obj <- DeeDeeExperiment::DeeDeeExperiment(obj)
  }

  obj <- DeeDeeExperiment::addFEA(obj, gsea, NAME)
  obj <- DeeDeeExperiment::renameFEA(obj, "gsea", paste0(NAME, "_gsea_", type))

  return(obj)
}

## Tests for the exported orchestration functions get.gos()/get.gsea().
# leading principle: we dont need to call all the external functions;
# they should work on their own, just test that the calls are correctly
## placed.

se_de <- se_with_de

make_de_se <- function(res_df) {
  se <- SummarizedExperiment::SummarizedExperiment(
    assays = list(
      counts = matrix(
        1,
        nrow = nrow(res_df),
        ncol = 1,
        dimnames = list(rownames(res_df), "s1")
      )
    )
  )
  S4Vectors::metadata(se)$de_results <- list(comparisonA = res_df)
  se
}

test_that("get.gos classifies up/down/universe genes and forwards them to enrichGO()", {
  res <- .de_result(se_de, "baseline")
  up_expected <- rownames(res)[which(res$padj < 0.05 & res$log2FoldChange > 1)]
  dn_expected <- rownames(res)[which(res$padj < 0.05 & res$log2FoldChange < -1)]
  universe_expected <- rownames(res)[which(!is.na(res$padj))]

  enrichGO_calls <- list()
  testthat::local_mocked_bindings(
    enrichGO = function(gene, OrgDb, keyType, ont, universe) {
      enrichGO_calls[[length(enrichGO_calls) + 1]] <<- list(
        gene = gene,
        keyType = keyType,
        ont = ont,
        universe = universe
      )
      if (length(gene) == 0) {
        return(NULL)
      }
      data.frame(ID = paste0("GO:", seq_along(gene)), Description = "term")
    },
    .package = "clusterProfiler"
  )

  addFEA_calls <- list()
  renameFEA_calls <- list()
  testthat::local_mocked_bindings(
    addFEA = function(x, y, name) {
      addFEA_calls[[length(addFEA_calls) + 1]] <<- list(name = name)
      x
    },
    renameFEA = function(x, old_name, new_name) {
      renameFEA_calls[[length(renameFEA_calls) + 1]] <<- list(
        old_name = old_name,
        new_name = new_name
      )
      x
    },
    .package = "DeeDeeExperiment"
  )

  result <- get.gos(
    "baseline",
    obj = se_de,
    species = "hs",
    gene_type = "ENSEMBL"
  )

  expect_true(methods::is(result, "DeeDeeExperiment"))

  # up/down classification is based on padj < 0.05 & |log2FC| > 1, NAs excluded
  up_calls <- Filter(function(x) setequal(x$gene, up_expected), enrichGO_calls)
  dn_calls <- Filter(function(x) setequal(x$gene, dn_expected), enrichGO_calls)
  expect_true(length(up_calls) > 0)
  expect_true(length(dn_calls) > 0)

  # universe excludes genes with NA padj
  expect_true(all(vapply(
    enrichGO_calls,
    function(x) setequal(x$universe, universe_expected),
    logical(1)
  )))

  expect_true(all(vapply(
    enrichGO_calls,
    function(x) x$keyType == "ENSEMBL",
    logical(1)
  )))
  expect_true(all(vapply(
    enrichGO_calls,
    function(x) x$ont == "BP",
    logical(1)
  )))

  expect_equal(length(addFEA_calls), 2)
  expect_true(all(vapply(
    addFEA_calls,
    function(x) x$name == "baseline",
    logical(1)
  )))

  expect_equal(
    vapply(renameFEA_calls, function(x) x$old_name, character(1)),
    c("up_go", "dn_go")
  )
  expect_equal(
    vapply(renameFEA_calls, function(x) x$new_name, character(1)),
    c("baseline_up_go", "baseline_down_go")
  )
})

test_that("get.gos skips addFEA/renameFEA when a direction has no significant genes", {
  # se_de has significant genes in both directions for every comparison, so
  # this edge case needs a hand-built comparison with only one direction hit.
  res_df <- data.frame(
    padj = c(0.001, 0.9),
    log2FoldChange = c(3, 0.1),
    row.names = c("UP1", "NS1")
  )
  se <- make_de_se(res_df)

  testthat::local_mocked_bindings(
    enrichGO = function(gene, OrgDb, keyType, ont, universe) {
      if (length(gene) == 0) {
        return(NULL)
      }
      data.frame(ID = paste0("GO:", seq_along(gene)))
    },
    .package = "clusterProfiler"
  )

  addFEA_calls <- list()
  testthat::local_mocked_bindings(
    addFEA = function(x, y, name) {
      addFEA_calls[[length(addFEA_calls) + 1]] <<- list(name = name)
      x
    },
    renameFEA = function(x, old_name, new_name) x,
    .package = "DeeDeeExperiment"
  )

  get.gos("comparisonA", obj = se, species = "hs", gene_type = "SYMBOL")

  expect_equal(length(addFEA_calls), 1)
})

test_that("get.gsea builds a descending gene ranking and forwards it to GSEA()", {
  msigdbr_calls <- list()
  testthat::local_mocked_bindings(
    msigdbr = function(collection, db_species, ...) {
      msigdbr_calls[[length(msigdbr_calls) + 1]] <<- list(
        collection = collection,
        db_species = db_species
      )
      data.frame(gs_name = "SET_A", gene_symbol = "GENE1")
    },
    .package = "msigdbr"
  )

  gsea_calls <- list()
  testthat::local_mocked_bindings(
    GSEA = function(geneList, TERM2GENE, ...) {
      gsea_calls[[length(gsea_calls) + 1]] <<- list(
        geneList = geneList,
        TERM2GENE = TERM2GENE
      )
      structure(list(), class = "mock_gsea_result")
    },
    .package = "clusterProfiler"
  )

  addFEA_calls <- list()
  renameFEA_calls <- list()
  testthat::local_mocked_bindings(
    addFEA = function(x, y, name) {
      addFEA_calls[[length(addFEA_calls) + 1]] <<- list(name = name)
      x
    },
    renameFEA = function(x, old_name, new_name) {
      renameFEA_calls[[length(renameFEA_calls) + 1]] <<- list(
        old_name = old_name,
        new_name = new_name
      )
      x
    },
    .package = "DeeDeeExperiment"
  )

  result <- get.gsea(
    NAME = "baseline",
    obj = se_de,
    type = "HALLMARK",
    conditions = c("trt", "untrt"),
    species = "hs",
    condition_var = "dex"
  )

  expect_true(methods::is(result, "DeeDeeExperiment"))

  expect_equal(length(msigdbr_calls), 1)
  expect_equal(msigdbr_calls[[1]]$collection, "H")
  expect_equal(msigdbr_calls[[1]]$db_species, "HS")

  expect_equal(length(gsea_calls), 1)
  rankings <- gsea_calls[[1]]$geneList

  expect_true(is.numeric(rankings))
  expect_true(!is.null(names(rankings)))
  # results are returned sorted from highest to lowest
  expect_true(all(diff(rankings) <= 0))

  # Cross-check the ranking direction against a plain, independently
  # computed mean-expression comparison
  # this might fail in some very specific circumstances, but within
  # airway it's fine

  counts_norm <- BiocGenerics::counts(se_de, normalized = TRUE)
  dex <- SummarizedExperiment::colData(se_de)$dex
  top_gene <- names(rankings)[1]
  bottom_gene <- names(rankings)[length(rankings)]
  expect_gt(
    mean(counts_norm[top_gene, dex == "trt"]),
    mean(counts_norm[top_gene, dex == "untrt"])
  )
  expect_gt(
    mean(counts_norm[bottom_gene, dex == "untrt"]),
    mean(counts_norm[bottom_gene, dex == "trt"])
  )

  expect_equal(length(addFEA_calls), 1)
  expect_equal(addFEA_calls[[1]]$name, "baseline")
  expect_equal(renameFEA_calls[[1]]$old_name, "gsea")
  expect_equal(renameFEA_calls[[1]]$new_name, "baseline_gsea_HALLMARK")
})

test_that("get.gsea requests the Reactome collection for type = 'REACTOME'", {
  msigdbr_calls <- list()
  testthat::local_mocked_bindings(
    msigdbr = function(collection, subcollection = NULL, db_species, ...) {
      msigdbr_calls[[length(msigdbr_calls) + 1]] <<- list(
        collection = collection,
        subcollection = subcollection,
        db_species = db_species
      )
      data.frame(gs_name = "SET_A", gene_symbol = "GENE1")
    },
    .package = "msigdbr"
  )
  testthat::local_mocked_bindings(
    GSEA = function(geneList, TERM2GENE, ...) {
      structure(list(), class = "mock_gsea_result")
    },
    .package = "clusterProfiler"
  )
  testthat::local_mocked_bindings(
    addFEA = function(x, y, name) x,
    renameFEA = function(x, old_name, new_name) x,
    .package = "DeeDeeExperiment"
  )

  get.gsea(
    NAME = "baseline",
    obj = se_de,
    type = "REACTOME",
    conditions = c("trt", "untrt"),
    species = "mm",
    condition_var = "dex"
  )

  expect_equal(msigdbr_calls[[1]]$collection, "C2")
  expect_equal(msigdbr_calls[[1]]$subcollection, "CP:REACTOME")
  expect_equal(msigdbr_calls[[1]]$db_species, "MM")
})

test_that("get.gsea's default condition_var works without being supplied explicitly", {
  # se_de's grouping column is called "dex", not "condition" - this test is
  # specifically about the literal default value, so it needs an object with
  # a colData column named "condition".
  counts <- matrix(
    c(
      100,
      110,
      90,
      10,
      12,
      8,
      10,
      12,
      8,
      100,
      110,
      90,
      50,
      52,
      48,
      50,
      51,
      49
    ),
    nrow = 3,
    byrow = TRUE
  )
  rownames(counts) <- paste0("GENE", 1:3)
  colnames(counts) <- paste0("S", 1:6)
  coldata <- data.frame(
    sample = colnames(counts),
    condition = factor(rep(c("groupA", "groupB"), each = 3)),
    row.names = colnames(counts)
  )
  dds <- DESeq2::DESeqDataSetFromMatrix(counts, coldata, design = ~condition)
  dds <- DESeq2::estimateSizeFactors(dds)

  testthat::local_mocked_bindings(
    msigdbr = function(...) {
      data.frame(gs_name = "SET_A", gene_symbol = "GENE1")
    },
    .package = "msigdbr"
  )
  gsea_calls <- list()
  testthat::local_mocked_bindings(
    GSEA = function(geneList, TERM2GENE, ...) {
      gsea_calls[[length(gsea_calls) + 1]] <<- list(geneList = geneList)
      structure(list(), class = "mock_gsea_result")
    },
    .package = "clusterProfiler"
  )
  testthat::local_mocked_bindings(
    addFEA = function(x, y, name) x,
    renameFEA = function(x, old_name, new_name) x,
    .package = "DeeDeeExperiment"
  )

  expect_no_error(
    get.gsea(
      NAME = "comparisonA",
      obj = dds,
      type = "HALLMARK",
      conditions = c("groupA", "groupB"),
      species = "hs"
    )
  )

  expect_equal(length(gsea_calls), 1)
  expect_true(is.numeric(gsea_calls[[1]]$geneList))
})

test_that("get.gsea accepts condition_var as either a symbol or a string", {
  testthat::local_mocked_bindings(
    msigdbr = function(...) {
      data.frame(gs_name = "SET_A", gene_symbol = "GENE1")
    },
    .package = "msigdbr"
  )
  testthat::local_mocked_bindings(
    addFEA = function(x, y, name) x,
    renameFEA = function(x, old_name, new_name) x,
    .package = "DeeDeeExperiment"
  )
  gsea_calls <- list()
  testthat::local_mocked_bindings(
    GSEA = function(geneList, TERM2GENE, ...) {
      gsea_calls[[length(gsea_calls) + 1]] <<- list(geneList = geneList)
      structure(list(), class = "mock_gsea_result")
    },
    .package = "clusterProfiler"
  )

  expect_no_error(
    get.gsea(
      NAME = "baseline",
      obj = se_de,
      type = "HALLMARK",
      conditions = c("trt", "untrt"),
      species = "hs",
      condition_var = dex
    )
  )
  expect_no_error(
    get.gsea(
      NAME = "baseline",
      obj = se_de,
      type = "HALLMARK",
      conditions = c("trt", "untrt"),
      species = "hs",
      condition_var = "dex"
    )
  )

  expect_equal(length(gsea_calls), 2)
  expect_equal(gsea_calls[[1]]$geneList, gsea_calls[[2]]$geneList)
})

# UI
ui <- function(request) {
  shiny::fluidPage(
    shiny::titlePanel("RNA-seq SummarizedExperiment Explorer"),
    # sidebar ----------
    shiny::sidebarLayout(
      shiny::sidebarPanel(
        width = 3,
        shiny::h4("Data Input"),
        shiny::fileInput(
          "se_file",
          "Upload SummarizedExperiment (.rds)",
          accept = ".rds"
        ),
        shiny::checkboxInput("use_demo", "Use Demo Data", value = TRUE),
        shiny::hr(),
        shiny::h4("Analysis Options"),

        shiny::conditionalPanel(
          condition = "input.main_tabs == 'PCA' | input.main_tabs == 'Gene Expression'",
          shiny::selectInput(
            "color_var",
            "Color/Group by:",
            choices = NULL
          ),
        ),

        shiny::conditionalPanel(
          condition = "input.main_tabs == 'Gene Expression' | input.main_tabs == 'Volcano Plot' | input.main_tabs == 'FC FC'",

          shiny::selectInput(
            "row_data_var",
            "Select the gene identifier",
            choices = NULL
          ),
        ),

        shiny::conditionalPanel(
          condition = "input.main_tabs == 'DE Results' | input.main_tabs == 'Volcano Plot' | input.main_tabs == 'Enrichment Results' | input.main_tabs == 'FC FC'",
          shiny::conditionalPanel(
            condition = "output.data_loaded",
            shiny::conditionalPanel(
              condition = "output.has_precomputed_de",
              shiny::selectInput(
                "de_comparison",
                "Select Comparison:",
                choices = NULL
              )
            ),
          )
        ),

        shiny::conditionalPanel(
          condition = "input.main_tabs == 'DE Results' | input.main_tabs == 'Volcano Plot' | input.main_tabs == 'Enrichment Results'",
          colourpicker::colourInput(
            "up_col",
            "Color for Upregulated",
            "#d62728"
          ),
          colourpicker::colourInput(
            "dn_col",
            "Color for Downregulated",
            "#1f77b4"
          ),
          colourpicker::colourInput(
            "high_col",
            "Color for Highlights",
            "#FFD700"
          )
        ),
        shiny::conditionalPanel(
          condition = "input.main_tabs == 'FC FC'",
          colourpicker::colourInput(
            "both_col",
            "Color for DE Overlap",
            "#ce1ae6"
          ),
          colourpicker::colourInput(
            "comp1_col",
            "Color for DE Comparison 1",
            "#0a31db"
          ),
          colourpicker::colourInput(
            "comp2_col",
            "Color for DE Comparison 2",
            "#f03405"
          ),
        )
      ),

      shiny::mainPanel(
        width = 9,
        shiny::tabsetPanel(
          id = "main_tabs",

          # tab overview ------
          shiny::tabPanel(
            "Overview",
            shiny::h3("Dataset Summary"),
            shiny::verbatimTextOutput("data_summary"),
            shiny::hr(),
            shiny::h4("Sample Metadata"),
            DT::DTOutput("metadata_table")
          ),
          # tab PCA ----
          shiny::tabPanel(
            "PCA",
            shiny::h3("Principal Component Analysis"),
            shiny::fluidRow(
              shiny::column(
                3,
                shiny::numericInput(
                  "top_genes",
                  "Top variable genes for PCA:",
                  value = 500,
                  min = 100,
                  max = 5000,
                  step = 100
                ),
                shiny::hr(),
              )
            ),
            plotly::plotlyOutput("pca_plot", height = "600px"),
            shiny::hr(),
            shiny::verbatimTextOutput("pca_variance")
          ),
          # tab gene expression ----
          shiny::tabPanel(
            "Gene Expression",
            shiny::h3("Gene Expression Plot"),
            shiny::fluidRow(
              shiny::column(
                3,
                shiny::checkboxGroupInput(
                  "groups_to_show",
                  "Include levels:"
                )
              ),
              shiny::column(
                3,
                shinyWidgets::pickerInput(
                  "gene_id",
                  "Select Gene:",
                  choices = NULL,
                  options = list(
                    `live-search` = TRUE,
                    `live-search-placeholder` = "Search genes...",
                    size = 10
                  )
                ),
                shiny::selectInput(
                  "plot_type",
                  "Plot Type:",
                  choices = c(
                    "Boxplot" = "box",
                    "Violin" = "violin"
                  )
                )
              )
            ),
            plotly::plotlyOutput("expr_plot", height = "500px"),
            shiny::hr(),
            shiny::h4("Expression Values"),
            DT::DTOutput("expr_table"),
            shiny::downloadButton(
              "download_expr",
              "Download Expression Table"
            )
          ),
          # tab de res ----------
          shiny::tabPanel(
            "DE Results",
            shiny::h3("Differential Expression Results"),
            shiny::uiOutput("de_status_message"),
            shiny::fluidRow(),
            shiny::conditionalPanel(
              condition = "!output.has_precomputed_de",
              shiny::actionButton(
                "run_de",
                "Run Basic DE Analysis",
                class = "btn-primary"
              )
            ),
            shiny::hr(),
            shiny::plotOutput("de_plot", height = "700px"),
            shiny::hr(),
            DT::DTOutput("de_table"),
            shiny::downloadButton("download_de", "Download DE Table")
          ),

          # tab volcano --------
          shiny::tabPanel(
            "Volcano Plot",
            shiny::h3("Volcano Plot"),
            shiny::fluidRow(
              shiny::column(
                3,
                shiny::numericInput(
                  "padj_cutoff_volcano",
                  "Adjusted p-value cutoff:",
                  value = 0.05,
                  min = 0,
                  max = 1,
                  step = 0.01
                )
              ),
              shiny::column(
                3,
                shiny::numericInput(
                  "lfc_cutoff_volcano",
                  "Log2 Fold Change cutoff:",
                  value = 1,
                  min = 0,
                  max = 10,
                  step = 0.5
                )
              ),
              shiny::column(
                3,
                shiny::checkboxInput(
                  "label_top",
                  "Label top genes",
                  value = TRUE
                ),
                shiny::numericInput(
                  "n_labels",
                  "Number to label:",
                  value = 10,
                  min = 0,
                  max = 50,
                  step = 5
                )
              )
            ),
            shiny::fluidRow(
              shiny::column(
                12,
                shiny::textAreaInput(
                  "highlight_genes",
                  "Highlight specific genes (one per line or comma-separated):",
                  value = "",
                  placeholder = "GENE1, GENE2, GENE3\nor\nGENE1\nGENE2\nGENE3",
                  rows = 3,
                  width = "100%"
                ),
                shiny::helpText(
                  "Enter gene IDs or gene names to highlight in yellow on the plot."
                )
              )
            ),
            shiny::hr(),
            plotly::plotlyOutput("volcano_plot", height = "700px"),
            shiny::hr(),
            shiny::h4("Summary Statistics")
          ),
          # tab enrichment ---
          shiny::tabPanel(
            "Enrichment Results",
            shiny::h3("Enrichment Results"),
            shiny::fluidRow(
              shiny::column(
                3,
                shiny::numericInput(
                  "padj_cutoff_enrichment",
                  "Adjusted p-value cutoff:",
                  value = 0.05,
                  min = 0,
                  max = 1,
                  step = 0.01
                )
              ),
              shiny::column(
                3,
                shiny::numericInput(
                  "n_terms_enrichment",
                  "Number of top terms to show:",
                  value = 10,
                  min = 3,
                  max = 20,
                  step = 1
                )
              )
            ),
            shiny::uiOutput("fe_status_message"),
            shiny::hr(),
            shiny::uiOutput("enrichment_plots", width = "700px")
          ),
          # tab fcfc ------
          shiny::tabPanel(
            "FC FC",
            shiny::h3("Fold Change comparisons"),
            shiny::fluidRow(),
            shiny::selectInput(
              "comparison_comparison",
              "Select Comparison:",
              choices = NULL
            ),
            shiny::hr(),
            plotly::plotlyOutput("fcfc_plot", height = "700px")
          )
        )
      )
    )
  )
}
# nocov start
server <- function(input, output, session) {
  # Increase upload size limit to 500MB
  options(shiny.maxRequestSize = 500 * 1024^2)

  # Reactive values --------
  rv <- shiny::reactiveValues(
    se = NULL,
    vst_data = NULL,
    pca_result = NULL,
    de_results = NULL,
    gene_idents = NULL,
  )

  has_precomputed_de <- shiny::reactive({
    shiny::req(rv$se)
    .check_precomputed_de(rv$se)
  })

  has_precomputed_fe <- shiny::reactive({
    shiny::req(rv$se)
    .check_precomputed_fe(rv$se)
  })

  # run observers --------------
  .create_interest_color_observers(input, session, rv)
  .observe_demo_data(input, session, rv)
  .observe_inital_obj(input, session, rv)
  .observe_load_file(input, session, rv)
  .create_rowvar_observer(input, session, rv)
  # precomputed results ---------

  # Get precomputed DE comparisons
  de_comparisons <- shiny::reactive({
    shiny::req(has_precomputed_de())
    .de_results_names(rv$se)
  })

  fes <- shiny::reactive({
    shiny::req(has_precomputed_fe())
    .fe_results_names(rv$se, input$de_comparison)
  })

  .observe_se_load(input, session, rv, has_precomputed_de, de_comparisons)

  # VST transformation -------
  vst_data <- shiny::reactive({
    shiny::req(rv$se)

    if (is.null(rv$vst_data)) {
      shiny::withProgress(message = "Transforming data...", {
        dds <- DESeq2::DESeqDataSet(rv$se, design = ~1)
        rv$vst_data <- SummarizedExperiment::assay(DESeq2::vst(
          dds,
          blind = TRUE
        ))
      })
    }
    rv$vst_data
  })

  # PCA calculation
  pca_data <- shiny::reactive({
    shiny::req(vst_data(), input$color_var, input$top_genes)

    vst_mat <- vst_data()

    # Select top variable genes
    rv_genes <- matrixStats::rowVars(vst_mat)
    select_genes <- order(rv_genes, decreasing = TRUE)[
      seq_len(min(input$top_genes, nrow(vst_mat)))
    ]

    # Run PCA
    pca <- stats::prcomp(t(vst_mat[select_genes, ]), scale. = FALSE)
    rv$pca_result <- pca

    # Create data frame for plotting
    pca_df <- data.frame(
      PC1 = pca$x[, 1],
      PC2 = pca$x[, 2],
      sample = colnames(rv$se),
      group = SummarizedExperiment::colData(rv$se)[[input$color_var]]
    )

    # Calculate variance explained
    var_explained <- round(100 * pca$sdev^2 / sum(pca$sdev^2), 1)

    list(data = pca_df, var = var_explained)
  })

  # Run DE analysis ----------
  shiny::observeEvent(input$run_de, {
    shiny::req(rv$se, input$color_var)

    shiny::withProgress(message = "Running DESeq2...", {
      tryCatch(
        {
          # Create DESeq2 object
          col_var <- input$color_var
          design_formula <- stats::as.formula(paste("~", col_var))
          dds <- DESeq2::DESeqDataSet(rv$se, design = design_formula)

          # Filter low counts
          keep <- rowSums(BiocGenerics::counts(dds)) >= 10
          dds <- dds[keep, ]

          # Run DESeq2
          dds <- DESeq2::DESeq(dds)

          # Get results
          res <- DESeq2::results(dds)
          rv$de_results <- as.data.frame(res) %>%
            tibble::rownames_to_column("gene_id") %>%
            dplyr::arrange(padj)

          shiny::showNotification(
            "DE analysis complete!",
            type = "message"
          )
        },
        error = function(e) {
          shiny::showNotification(
            paste("Error in DE analysis:", e$message),
            type = "error"
          )
        }
      )
    })
  })

  # current DE results ---------
  current_de_results <- shiny::reactive({
    if (has_precomputed_de() && !is.null(input$de_comparison)) {
      # Load precomputed results

      de_res <- .de_result(rv$se, input$de_comparison) %>%
        tibble::rownames_to_column("gene_ident")

      merging_data <- SummarizedExperiment::rowData(rv$se) |>
        as.data.frame() |>
        dplyr::select(tidyselect::any_of(rv$gene_idents)) |>
        tibble::rownames_to_column("gene_ident")
      de_res <- merging_data |>
        dplyr::left_join(de_res, by = dplyr::join_by(gene_ident))
      return(de_res)
    } else if (!is.null(rv$de_results)) {
      # Use computed results
      return(rv$de_results)
    } else {
      return(NULL)
    }
  })

  # current FE results ------
  current_fe_results <- shiny::reactive({
    if (has_precomputed_fe()) {
      # Load precomputed results
      if (methods::is(rv$se, "DeeDeeExperiment")) {
        fe_res <- .fe_result(rv$se, input$de_comparison)
      } else {
        fe_res <- S4Vectors::metadata(rv$se)$fe_results[[
          input$de_comparison
        ]]
      }
      return(fe_res)
    } else {
      return(NULL)
    }
  })

  # Outputs ---------------
  output$data_loaded <- shiny::reactive({
    !is.null(rv$se)
  })
  shiny::outputOptions(output, "data_loaded", suspendWhenHidden = FALSE)

  output$has_precomputed_de <- shiny::reactive({
    has_precomputed_de()
  })
  output$has_precomputed_fe <- shiny::reactive({
    has_precomputed_fe()
  })
  shiny::outputOptions(
    output,
    "has_precomputed_de",
    suspendWhenHidden = FALSE
  )
  shiny::outputOptions(
    output,
    "has_precomputed_fe",
    suspendWhenHidden = FALSE
  )

  output$de_status_message <- shiny::renderUI({
    if (has_precomputed_de()) {
      comparisons <- de_comparisons()
      htmltools::tagList(
        htmltools::p(
          shiny::icon("check-circle", class = "text-success"),
          htmltools::strong(paste(
            "Found",
            length(comparisons),
            "precomputed DE comparison(s):"
          )),
          htmltools::br(),
          paste(comparisons, collapse = ", ")
        )
      )
    } else {
      htmltools::p(
        shiny::icon("info-circle"),
        "No precomputed DE results found. Run basic DE analysis or upload data with results in metadata(se)$de_results."
      )
    }
  })
  output$fe_status_message <- shiny::renderUI({
    if (has_precomputed_fe()) {
      comparisons <- names(current_fe_results())
      htmltools::tagList(
        htmltools::p(
          shiny::icon("check-circle", class = "text-success"),
          htmltools::strong(paste(
            "Found",
            length(comparisons),
            "precomputed functional enrichment(s):"
          )),
          htmltools::br(),
          paste(comparisons, collapse = ", ")
        )
      )
    } else {
      htmltools::p(
        shiny::icon("info-circle"),
        "No precomputed FE results found. Run basic FE analysis or upload data with results in metadata(se)$fe_results."
      )
    }
  })

  output$data_summary <- shiny::renderText({
    shiny::req(rv$se)

    assay_names <- paste(
      names(SummarizedExperiment::assays(rv$se)),
      collapse = ", "
    )
    sample_metadata_cols <- paste(
      colnames(SummarizedExperiment::colData(rv$se)),
      collapse = ", "
    )

    summary_lines <- c(
      "SummarizedExperiment Object",
      "===========================",
      "",
      "Dimensions:",
      paste("  Genes:", nrow(rv$se)),
      paste("  Samples:", ncol(rv$se)),
      "",
      paste("Assays:", assay_names),
      "",
      "Sample Metadata Columns:",
      paste(" ", sample_metadata_cols)
    )

    if (ncol(SummarizedExperiment::rowData(rv$se)) > 0) {
      gene_metadata_cols <- paste(
        colnames(SummarizedExperiment::rowData(rv$se)),
        collapse = ", "
      )
      summary_lines <- c(
        summary_lines,
        "",
        "Gene Metadata Columns:",
        paste(" ", gene_metadata_cols)
      )
    }

    paste(summary_lines, collapse = "\n")
  })

  output$metadata_table <- DT::renderDT({
    shiny::req(rv$se)
    DT::datatable(
      as.data.frame(SummarizedExperiment::colData(rv$se)),
      options = list(pageLength = 10, scrollX = TRUE),
      rownames = TRUE
    )
  })

  output$pca_plot <- plotly::renderPlotly({
    shiny::req(pca_data())

    pca_info <- pca_data()
    df <- pca_info$data
    var <- pca_info$var

    p <- ggplot2::ggplot(
      df,
      ggplot2::aes(x = PC1, y = PC2, color = group, text = sample)
    ) +
      ggplot2::geom_point(size = 4, alpha = 0.8) +
      ggplot2::labs(
        x = paste0("PC1 (", var[1], "%)"),
        y = paste0("PC2 (", var[2], "%)"),
        color = input$color_var
      ) +
      ggplot2::theme_minimal(base_size = 14) +
      ggplot2::theme(legend.position = "right")

    plotly::ggplotly(p, tooltip = c("text", "group")) %>%
      plotly::layout(hovermode = "closest")
  })

  output$pca_variance <- shiny::renderText({
    shiny::req(rv$pca_result)
    var_explained <- round(
      100 * rv$pca_result$sdev^2 / sum(rv$pca_result$sdev^2),
      2
    )
    top_pcs <- seq_len(min(10, length(var_explained)))
    paste(
      c(
        "Variance Explained by PCs:",
        sprintf("  PC%d: %.2f%%", top_pcs, var_explained[top_pcs])
      ),
      collapse = "\n"
    )
  })
  ## expression plot-------
  output$expr_plot <- plotly::renderPlotly({
    shiny::req(rv$se, input$gene_id, input$color_var)

    p <- .plot_expression(
      rv$se,
      input$gene_id,
      input$color_var,
      input$groups_to_show,
      input$plot_type,
      input$row_data_var
    )
    plotly::ggplotly(p)
  })

  output$expr_table <- DT::renderDT({
    shiny::req(
      rv$se,
      input$gene_id,
      input$groups_to_show,
      input$row_data_var
    )

    gene <- rownames(SummarizedExperiment::rowData(rv$se)[
      which(
        SummarizedExperiment::rowData(rv$se)[, input$row_data_var] ==
          input$gene_id
      ),
    ])[1]
    expr_data <- data.frame(
      Sample = colnames(rv$se),
      SummarizedExperiment::colData(rv$se),
      Gene = input$gene_id,
      Count = SummarizedExperiment::assay(rv$se, "counts")[gene, ],
      g_r_o_u_p = SummarizedExperiment::colData(rv$se)[[input$color_var]]
    ) %>%
      dplyr::filter(g_r_o_u_p %in% input$groups_to_show) %>%
      dplyr::select(-g_r_o_u_p)

    DT::datatable(
      expr_data,
      options = list(pageLength = 12, scrollX = TRUE),
      rownames = FALSE
    ) %>%
      DT::formatRound("Count", digits = 0)
  })

  output$de_table <- DT::renderDT({
    de_data <- current_de_results()
    de_data <- dplyr::select(
      de_data,
      tidyselect::any_of(c(
        "gene_ident",
        rv$gene_idents,
        "baseMean",
        "log2FoldChange",
        "pvalue",
        "padj"
      ))
    ) %>%
      dplyr::mutate(
        dplyr::across(
          tidyselect::any_of(c("baseMean", "log2FoldChange")),
          \(x) round(x, 2)
        ),
        dplyr::across(tidyselect::any_of(c("pvalue", "padj")), \(x) {
          round(x, 4)
        })
      )
    shiny::req(de_data)

    DT::datatable(
      de_data,
      options = list(pageLength = 25, scrollX = TRUE),
      rownames = FALSE,
      filter = "top"
    )
  })

  output$de_plot <- shiny::renderPlot({
    colors_acute <- c(
      "Up" = input$up_col,
      "Down" = input$dn_col,
      "NS" = "grey70",
      "Highlighted" = input$highlight_col
    )
    de_data <- current_de_results()

    .plot_des(
      de_data,
      input$de_comparison,
      input$padj_cutoff_volcano,
      input$lfc_cutoff_volcano,
      colors_acute
    )
  })

  output$download_expr <- shiny::downloadHandler(
    filename = function() {
      comparison_name <- stringr::str_replace(
        input$gene_id,
        "[^a-zA-Z0-9_-]",
        "_"
      )

      paste0(comparison_name, "_expression_data_", Sys.Date(), ".csv")
    },
    content = function(file) {
      shiny::req(rv$se, input$gene_id, input$groups_to_show)

      gene <- input$gene_id
      expr_data <- data.frame(
        Sample = colnames(rv$se),
        SummarizedExperiment::colData(rv$se),
        Gene = input$gene_id,
        Count = SummarizedExperiment::assay(rv$se, "counts")[gene, ],
        g_r_o_u_p = SummarizedExperiment::colData(rv$se)[[
          input$color_var
        ]]
      ) %>%
        dplyr::filter(g_r_o_u_p %in% input$groups_to_show) %>%
        dplyr::select(-g_r_o_u_p)
      readr::write_excel_csv2(expr_data, file)
    }
  )

  output$download_de <- shiny::downloadHandler(
    filename = function() {
      comparison_name <- if (
        has_precomputed_de() && !is.null(input$de_comparison)
      ) {
        gsub("[^a-zA-Z0-9_-]", "_", input$de_comparison)
      } else {
        "DE_results"
      }
      paste0(comparison_name, "_", Sys.Date(), ".csv")
    },
    content = function(file) {
      de_data <- current_de_results()
      shiny::req(de_data)
      readr::write_excel_csv2(de_data, file)
    }
  )

  ## Volcano plot ----
  output$volcano_plot <- plotly::renderPlotly({
    de_data <- current_de_results()
    shiny::req(
      de_data,
      input$row_data_var
    )
    colors_acute <- c(
      "Up" = input$up_col,
      "Down" = input$dn_col,
      "NS" = "grey70",
      "Highlighted" = input$highlight_col
    )

    highlight_vec <- c()
    if (
      !is.null(input$highlight_genes) &&
        nchar(trimws(input$highlight_genes)) > 0
    ) {
      # Split by newlines and commas, trim whitespace
      highlight_vec <- input$highlight_genes %>%
        strsplit("[\n,]") %>%
        unlist() %>%
        trimws() %>%
        .[nchar(.) > 0]
    }

    .plot_volcano(
      RES = de_data,
      NAME = input$de_comparison,
      padj_CO = input$padj_cutoff_volcano,
      fc_CO = input$lfc_cutoff_volcano,
      highlights = highlight_vec,
      COLS = colors_acute,
      LABEL_TOP = input$label_top,
      TOPN = input$n_labels,
      gene_var = input$row_data_var
    )
  })

  ## enrichment plots -------
  output$enrichment_plots <- shiny::renderUI({
    current_fes <- current_fe_results()
    colors_acute <- c(
      "Up" = input$up_col,
      "Down" = input$dn_col,
      "NS" = "grey70",
      "Highlighted" = input$highlight_col
    )
    shiny::req(
      current_fes,
      input$padj_cutoff_enrichment,
      input$n_terms_enrichment,
      colors_acute
    )

    plots <- purrr::imap(current_fes, function(enrich, name) {
      id <- paste0("e_plot_", name)

      output[[id]] <- plotly::renderPlotly({
        .plot_fe(
          FE = enrich,
          NAME = name,
          padj_CO = input$padj_cutoff_enrichment,
          N_terms = input$n_terms_enrichment,
          COLS = colors_acute
        )
      })
    })
  })

  output$fcfc_plot <- plotly::renderPlotly({
    shiny::req(
      rv$se,
      input$padj_cutoff_volcano,
      input$lfc_cutoff_volcano,
      input$comp1_col,
      input$comp2_col
    )
    colors_acute <- c(
      "Comp1" = input$comp1_col,
      "Comp2" = input$comp2_col,
      "ns" = "grey70",
      "both" = input$both_col
    )
    .plot_fcfc(
      OBJ = rv$se,
      NAME = input$de_comparison,
      PARTNER_NAME = input$comparison_comparison,
      GENE_VAR = input$row_data_var,
      GENE_VARS = rv$gene_idents,
      padj_CO = input$padj_cutoff_volcano,
      fc_CO = input$lfc_cutoff_volcano,
      COLS = colors_acute
    )
  })
}
# nocov end

# Run app
#' exploreSE
#'
#'
#' @description
#' This runs the explorer app. You can add a path to a .rds file or a the
#' relevant R object as an argument to load it on start-up.
#' The app looks for DE results in the metadata of the metadata(object)$de_results
#' and, if it is a DeeDeeExperiment, in the DEA slots of the object.
#' Similarly, the enrichment results are looked for in the metadata(object)$fe_results
#' or FEA slots (DeeDeeExperiment). As the DeeDeeExperiment structure does
#' a lot of work to clean and standardize the inputs and outputs for both DE
#' and enrichment results, using it is highly recommended.
#'
#' @param file a string leading to a file you want loaded as a default
#' @param object a summarizedExperiment object (or DeeDeeExperiment) to load in
#'
#' @returns an application
#' @export
#'
#' @examples
#' app <- exploreSE()
#' if(interactive()){
#' shiny::runApp(app, port = 1234)
#'}

exploreSE <- function(file = NULL, object = NULL) {
  shiny::shinyOptions(set_file_name = file, set_object = object)
  shiny::shinyApp(ui, server)
}

utils::globalVariables(c(
  "padj",
  "PC1",
  "PC2",
  "group",
  "s_a_m_p_l_e",
  "g_r_o_u_p",
  "log2FoldChange",
  ".",
  "gene_id",
  "gene_name",
  "sig",
  "highlighted",
  "display_category",
  "p.adjust",
  "FoldEnrichment",
  "Description",
  "geneID",
  "NES",
  "BR",
  "BgRatio",
  "GR",
  "GeneRatio",
  "dds",
  "condition",
  "gs_name",
  "gene_symbol",
  "gene",
  "name",
  "value",
  "sd",
  "mean_expr",
  "sd_group1",
  "sd_group2",
  "ranking",
  "mean_expr_group2",
  "mean_expr_group1",
  "n",
  "direction",
  "ensembl_gene",
  "ncbi_gene",
  "sample_ident",
  "gene_ident",
  "sig_A",
  "sig_B",
  "log2FoldChange_A",
  "log2FoldChange_B"
))

library(DeeDeeExperiment)
library(airway)

data(airway)
airway <- DESeq2::estimateSizeFactors(DESeq2::DESeqDataSet(
  airway,
  design = ~dex
))
airway <- DeeDeeExperiment(airway)

data("baseline_de", package = "exploreSE")
data("controlled_de", package = "exploreSE")

se_with_de <- addDEA(airway, baseline)
se_with_de <- addDEA(se_with_de, cell_controlled)

data("baseline_up_go", package = "exploreSE")
data("baseline_down_go", package = "exploreSE")

data("controlled_up_go", package = "exploreSE")
data("controlled_down_go", package = "exploreSE")


se_with_go <- DeeDeeExperiment::addFEA(se_with_de, baseline_up_go, "baseline")
se_with_go <- DeeDeeExperiment::addFEA(se_with_go, baseline_down_go, "baseline")
se_with_go <- DeeDeeExperiment::addFEA(
  se_with_go,
  controlled_up_go,
  "controlled"
)
se_with_go <- DeeDeeExperiment::addFEA(
  se_with_go,
  controlled_down_go,
  "controlled"
)

.create_interest_color_observers <- function(input, session, rv) {
  # nocov start
  shiny::observe({
    if (!is.null(rv$se)) {
      shiny::updateCheckboxGroupInput(
        session,
        "groups_to_show",
        choices = levels(SummarizedExperiment::colData(rv$se)[[
          input$color_var
        ]]),
        selected = levels(SummarizedExperiment::colData(rv$se)[[
          input$color_var
        ]])
      )
    }
  })

  # nocov end
}

.create_rowvar_observer <- function(input, session, rv) {
  # nocov start

  shiny::observeEvent(input$row_data_var, {
    if (
      !is.null(rv$se) &&
        !is.null(SummarizedExperiment::rowData(rv$se)) &&
        input$row_data_var %in%
          colnames(SummarizedExperiment::rowData(rv$se))
    ) {
      gene_choices <- SummarizedExperiment::rowData(rv$se)[,
        input$row_data_var,
        drop = TRUE
      ]

      shinyWidgets::updatePickerInput(
        session,
        "gene_id",
        choices = gene_choices,
        selected = gene_choices[1]
      )
    }
  })
  # nocov end
}


.observe_demo_data <- function(input, session, rv) {
  # nocov start

  shiny::observe({
    if (input$use_demo) {
      rv$se <- .create_demo_data()
    }
  })
  # nocov end
}


.observe_inital_obj <- function(input, session, rv) {
  set_file <- shiny::getShinyOption("set_file_name")
  set_object <- shiny::getShinyOption("set_object")

  # nocov start

  shiny::observe({
    shiny::req(set_file)
    rv$se <- readRDS(set_file)
    shiny::updateCheckboxInput(session, "use_demo", value = FALSE)
    shiny::showNotification("Data loaded successfully!", type = "message")
  })

  shiny::observe({
    shiny::req(set_object)
    rv$se <- set_object
    shiny::updateCheckboxInput(session, "use_demo", value = FALSE)
    shiny::showNotification("Data loaded successfully!", type = "message")
  })

  # nocov end
}


.observe_se_load <- function(
  input,
  session,
  rv,
  has_precomputed_de,
  de_comparisons
) {
  # nocov start
  shiny::observeEvent(rv$se, {
    shiny::req(rv$se)

    col_vars <- colnames(SummarizedExperiment::colData(rv$se))

    row_vars <- SummarizedExperiment::rowData(rv$se) |>
      as.data.frame() |>
      dplyr::select(
        tidyselect::where(is.character),
        tidyselect::contains("id"),
        tidyselect::contains("entrez")
      ) |>
      dplyr::select(tidyselect::where(\(x) {
        !all(is.na(x)) & dplyr::n_distinct(x, na.rm = TRUE) > 1
      })) |>
      names()
    rv$gene_idents <- row_vars

    default_col_var <- if ("condition" %in% col_vars) {
      "condition"
    } else {
      col_vars[1]
    }

    shiny::updateSelectInput(
      session,
      "color_var",
      choices = col_vars,
      selected = default_col_var
    )

    default_row_var <- if ("gene_name" %in% row_vars) {
      "gene_name"
    } else if ("SYMBOL" %in% stringr::str_to_upper(row_vars)) {
      row_vars[which(stringr::str_to_upper(row_vars) == "SYMBOL")[1]]
    } else {
      row_vars[1]
    }
    shiny::updateSelectInput(
      session,
      "row_data_var",
      choices = row_vars,
      selected = default_row_var
    )

    # Update gene choices with searchable picker
    gene_choices <- SummarizedExperiment::rowData(rv$se)[,
      default_row_var,
      drop = TRUE
    ]

    shinyWidgets::updatePickerInput(
      session,
      "gene_id",
      choices = gene_choices,
      selected = gene_choices[1]
    )

    # Update DE comparison choices if precomputed results exist
    if (has_precomputed_de()) {
      comparisons <- de_comparisons()
      shiny::updateSelectInput(
        session,
        "de_comparison",
        choices = comparisons,
        selected = comparisons[1]
      )
      #for fcfc
      shiny::updateSelectInput(
        session,
        "comparison_comparison",
        choices = comparisons,
        selected = comparisons[1]
      )
      shiny::showNotification(
        paste(
          "Found",
          length(comparisons),
          "precomputed DE comparison(s)"
        ),
        type = "message"
      )
    }
  })
  # nocov end
}


.observe_load_file <- function(input, session, rv) {
  # nocov start
  shiny::observeEvent(input$se_file, {
    shiny::req(input$se_file)
    tryCatch(
      {
        rv$se <- readRDS(input$se_file$datapath)
        shiny::updateCheckboxInput(session, "use_demo", value = FALSE)
        shiny::showNotification(
          "Data loaded successfully!",
          type = "message"
        )
      },
      error = function(e) {
        shiny::showNotification(
          paste("Error loading file:", e$message),
          type = "error"
        )
      }
    )
  })
  # nocov end
}

---
title: "Introduction to exploreSE"
author:
- name: Jasper Spitzer
  affiliation: Institute for Human Genetics, University Hoospital Bonn, Germany
  email: jasspitzer135@gmail.com
date: "`r BiocStyle::doc_date()`"
output:
  BiocStyle::html_document:
    toc: true
    toc_depth: 2
vignette: >
  %\VignetteIndexEntry{Introduction to exploreSE}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Introduction 
exploreSE is package that provides an interactive Shiny-based user interface for exploring transcriptional data and analysis results stored in [summarizedExperiment](https://www.bioconductor.org/packages/release/bioc/html/tidySummarizedExperiment.html) or [DeeDeeExperiment](https://bioconductor.org/packages//release/bioc/html/DeeDeeExperiment.html) format. The aim is to facilitate easy comparison between different model approaches on a single data set. 

The package can be installed via the `BiocManager` by starting R and running: 
```{r install, eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE)) {
  install.packages("BiocManager")
}

BiocManager::install("exploreSE")
```

Once installed, the packages can be accessed through the following bit of code:

```{r library}
library(exploreSE)
```

To explore the results of differential expression analysis, we need to organise them in the structure and you will learn how to do that in this vignette. If you want to explore on your own, you can  run the following code and start exploring the example data.

```{r quickstart, eval=FALSE}
example(exploreSE, ask = FALSE)
```



# Setting up the data
For the purposes of this example, we'll be using the `airway` data. It is part of the [airway](https://www.bioconductor.org/packages/release/data/experiment/html/airway.html) package, containing RNA-Seq data from different airway smooth muscle cell lines either untreated or treated with dexamethasone.

```{r airway-dataset}
library(airway)
data(airway)
airway
```

Out of the box, the `airway` object is `summarizedExperiment` object, containing eight samples from four cell lines. This information is available in `coldata(airway)`.

```{r coldata_example}
colData(airway)
```

In this vignette, we will subset `airway` to only contain protein-coding genes. The required information is stored in its `rowData`, accessible through `rowData(airway)`.

```{r rowdata_example}
rowData(airway)
```

```{r example_filtering}
dim(airway)
airway <- airway[rowData(airway)$gene_biotype == "protein_coding", ]
dim(airway)
```

Let's start our anaylsis. Using the [DESeq2](https://bioconductor.org/packages/release/bioc/html/DESeq2.html) package, we will convert airway into an `DESeqDataSet` and build a simple model based the dexamethasone stimulation stored in the `dex` variable. 


```{r example_adding_baseline}
library(DESeq2)
airway <- DESeqDataSet(airway, design = ~dex)
airway <- DESeq(airway)
baseline <- results(airway)
```

In addition, we'll build a second model, where we control for the effect of the cell line, stored in the `cell` variable: 

```{r example_adding_controlled}
design(airway) <- ~ cell + dex
airway <- DESeq(airway)
cell_controlled <- results(airway)
```

Using the [DeeDeeExperiment](https://bioconductor.org/packages//release/bioc/html/DeeDeeExperiment.html) package, we will store these results in the their respective slots. 

```{r example_deedee}
library(DeeDeeExperiment)
airway <- DeeDeeExperiment(airway)
airway <- addDEA(airway, baseline)
airway <- addDEA(airway, cell_controlled)
```

Let's take a look:

```{r example_structure_showcase}
airway
```

In addition to differential expression anaylsis, we can also explore some biological data mining, in this case GO ORA. Here we use the `get.gos()` function from the `exploreSE` package, but it just populates the FEA slot of the DeeDeeExperiment. 


```{r example_gos}
airway <- get.gos(obj = airway, NAME = "baseline", gene_type = "ENSEMBL")
airway <- get.gos(obj = airway, NAME = "cell_controlled", gene_type = "ENSEMBL")
```

```{r example_showcase_with_gos}
airway
```

Now that our data is ready, we can explore the data. 

# Launching the App
The simplest way to launch the app is through a call to the `exploreSE()` function. Without any arguments, the app opens and you can load in any .RDS file. Alternatively, you can supply the `file` argument, defining the path to the file, or the `object` argument when you have the object already loaded.

```{r running_the_app, eval=FALSE}
app <- exploreSE(object = airway)
shiny::runApp(app, port = 1234)
```

![Opening View.](screenshots/opening_view.png)

After starting the app, you are created with an overview of the metadata in the `colData` of the relevant `summarizedExperiment`, as well as a search- and scrollable view of the same table. 
On the left hand side, you can load in a different object from the local environment if desired under the "Data Input header" - should you start up the app without any data, the "Use Demo Data" checkbox will be checked and some demo data will be generated for you. 
Below that, you will find some options for the your data exploration throughout the app. Options that are specific to the one panel only are integrated into that panel, but globally relevant options appear in the sidebar as needed.
You will have your choice of the relevant gene identifier; by default it picks the first column from your `rowData`, but with the drop-down menu that behavior can be changed.
Secondly, you can pick your differential expression analysis; these come from the relevant slots from the underlying `DeeDeeExperiment` or m̀etdata()`. 


## Overview
On the top side, you have 6 riders to choose from: 
1. Overview,  currently selected
2. PCA; an overview of the principle component visualisation 
3. Gene Expression, where the expression of a selected gene is visualised
4. DE Results; the currently selected DE comparison is summarised and visualised
5. Volcano Plot: a volcano plot of the selected DE comparison
6. Enrichment Results: present enrichment results are plotted


## PCA view
Progressing through the app, you can navigate to the PCA rider.
![View of the PCA rider](screenshots/pca_baseline.png)

You can select the coloring scheme of the the points in the drop down menu, as well as how many genes are used to calculate the PCA. 
In the `airway` dataset, the dexamethasone treatment, saved in the `dex` variable, is the primary variable of interest, but you can also select other from the dropdown menu. 

![Alternate coloring of the PCA](screenshots/pca_dex.png)


## Expression plotting

Navigating to the Gene Expression tab, you can check the expression of selected genes. By selecting a value in the Color/Group by drop-down menu, you can select the value on the x-axis. You can also include/exclude certain levels of that variable through the tick boxes on the left. The gene being plotted is selected by the "Select Gene" dropdown, which is searchable. Any values visible in the plot can be exported from the table below. 

![Overview of the Gene Expression panel](screenshots/expression.png)


## DE Results

The heart of this application is the comparison of different possible models and within this tab, we are starting that process. 

![Differential expression overview for the baseline model.](screenshots/de_baseline.png)

On the top of the page, a little overview indicates all the comparisons found in the respective slots. 
Below, a barchart indicates the number of differentially expressed genes. The specifics of the results can looked up in a table below and exported. 

This view also exists for each comparison; selecting a different comparison from the drop-down menu on the left hand side refreshes the view:

![Differential expression overview for the cell-controlled model.](screenshots/de_controlled.png)

## Volcano plot

A graphical overview over the differential expression can be found in the Volcano Plot tab.

![Volcano plot of the baseline model.](screenshots/volcano_baseline.png)

On the top of this tab, a variety of graphical settings can be determined: the cutoffs for the different colors, a number of genes to label and the colorcode are all freely changeable. Again, this view depends on the selected comparison. 

## Enrichment results 

For interpretation of these results, you often rely on the different enrichment methods that to determine which biological themes or pathways are altered in a given comparison. These results are visualised in the Enrichment Results tab.

![Enrichment results for the baseline model.](screenshots/gos_baseline.png)

In this case, we are looking at the GO term enrichments for the baseline model. Like before, some graphical adjustments can be set at the top. Below, we have two bar charts, one for each direction of the comparison. The genes driving the enrichment are written inside the bars. 

## Comparison of Fold Changes

Direct comparison of fold changes across models can generate insights into the differences. For this, two models can be selected and their respective fold changes plotted against each other.

![FC-FC plot of the baseline and cell-controlled models.](screenshots/fc_fc.png)] 

# FAQ

**Q: How do I add results into the summarizedExperiment?**
A: The easiest way is to use the `DeeDeeExperiment` extension of the `summarizedExperiment` class. You can use the dedicated DEA and FEA slots. There is a detailed explanation [here](https://bioconductor.org/packages//release/bioc/vignettes/DeeDeeExperiment/inst/doc/DeeDeeExperiment_manual.html). If you do not want that, you can add it to the `summarizedExperiment` metadata, using `de-results`and `fe_results`as names. 
**Q: can I use the explorer to perform analysis?**
A: No, this app is only design to visualise already performed analyses. All decisions on what to test, what enrichments to run should happen before you start the app and make use of the package. 

# Session Info

```{r session_info}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/se_utils.R
\name{get.gos}
\alias{get.gos}
\title{Calculate GO Enrichments for a given comparison}
\usage{
get.gos(NAME, obj, species = "hs", gene_type = "SYMBOL")
}
\arguments{
\item{NAME}{character, name of the DE comparison}

\item{obj}{DeeDeeExperiment or SummarizedExperiment, the object}

\item{species}{character, the species hs/mm}

\item{gene_type}{character, the type of gene identifier}
}
\value{
a DeeDeeExperiment or SummarizedExperiment
}
\description{
A function to calculate GO term enrichments from a given summarizedExperiment
or DeeDee experiment. By default, it calculates separate enrichments for
up- downregulated genes, at the cutoffs of |logFC| > 1 and adjusted p-
value < 0.05. It utilises the \code{\link[clusterProfiler:enrichGO]{clusterProfiler::enrichGO()}} function.
}
\examples{

library(airway)
library(DeeDeeExperiment)
data(airway)
data("baseline_de", package = "exploreSE")

se_with_de <- addDEA(DeeDeeExperiment(airway), baseline)
se_with_go <- get.gos(obj = se_with_de,
                      NAME = "baseline",
                      gene_type = "ENSEMBL")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example_data.R
\docType{data}
\name{baseline}
\alias{baseline}
\title{DE results for airway - baseline}
\format{
A DESEqResults
}
\value{
A DESEqResults
}
\description{
Example DE results for airway data set
}
\details{
This is a \code{DESEqResults} object, with the simplest model, using \code{~dex} as
the design. Data is from the airway package, DE results are generated with \code{DESeq2}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example_data.R
\docType{data}
\name{baseline_down_go}
\alias{baseline_down_go}
\title{Example GO enrichments for the baseline model}
\format{
A EnrichResults
}
\value{
A EnrichResults object
}
\description{
GO enrichments based on the \code{baseline} DE results
}
\details{
GO enrichmens are generated with \code{clusterProfiler}, filtered on down-regulated
genes only; genes that underwent DE testing were taken as the universe.

The code to create said object can be found in the folder \verb{/inst/scripts} in
the exploreSE package, the file is called \code{creating_dataset_examples.R}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exploreSE.R
\name{exploreSE}
\alias{exploreSE}
\title{exploreSE}
\usage{
exploreSE(file = NULL, object = NULL)
}
\arguments{
\item{file}{a string leading to a file you want loaded as a default}

\item{object}{a summarizedExperiment object (or DeeDeeExperiment) to load in}
}
\value{
an application
}
\description{
This runs the explorer app. You can add a path to a .rds file or a the
relevant R object as an argument to load it on start-up.
The app looks for DE results in the metadata of the metadata(object)$de_results
and, if it is a DeeDeeExperiment, in the DEA slots of the object.
Similarly, the enrichment results are looked for in the metadata(object)$fe_results
or FEA slots (DeeDeeExperiment). As the DeeDeeExperiment structure does
a lot of work to clean and standardize the inputs and outputs for both DE
and enrichment results, using it is highly recommended.
}
\examples{
app <- exploreSE()
if(interactive()){
shiny::runApp(app, port = 1234)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example_data.R
\docType{data}
\name{cell_controlled}
\alias{cell_controlled}
\title{DE results for airway - cell-controlled}
\format{
A DESEqResults
}
\value{
A DESEqResults
}
\description{
Example DE results for airway data set
}
\details{
This is a \code{DESEqResults} object, using \code{~ cell + dex} as the design.
Data is from the airway package, DE results are generated with \code{DESeq2},
using the \verb{dex untrt vs trt} contrast
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exploreSE-package.R
\docType{package}
\name{exploreSE-package}
\alias{exploreSE-package}
\title{exploreSE: Explorer for Your Bulk RNA Seq Analyses}
\description{
Interactive exploration of a Summarized experiment and associated DE analyses. A shiny app to inspect and interact with pre-calculated differential expression and functional enrichment results, and to facilitate comparisons between multiple models. This is meant to be a tool for exploration and discussion, rather than analysis.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/jaspitzer/exploreSE}
  \item Report bugs at \url{https://github.com/jaspitzer/exploreSE/issues}
}

}
\author{
\strong{Maintainer}: Jasper Spitzer \email{jasspitzer135@gmail.com} (\href{https://orcid.org/0000-0001-9696-2092}{ORCID})

Authors:
\itemize{
  \item Jasper Spitzer \email{jasspitzer135@gmail.com} (\href{https://orcid.org/0000-0001-9696-2092}{ORCID})
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/se_utils.R
\name{get.gsea}
\alias{get.gsea}
\title{Calculate GSEA Enrichments for a given comparison}
\usage{
get.gsea(
  NAME,
  obj,
  type = "HALLMARK",
  conditions,
  species = "hs",
  condition_var = "condition",
  gene_type = "SYMBOL"
)
}
\arguments{
\item{NAME}{character, name of the DE comparison}

\item{obj}{DeeDeeExperiment or SummarizedExperiment, the object}

\item{type}{character, the type of gene set, HALLMARK or REACTOME}

\item{conditions}{a vector of length 2, which levels of the condition variable are being compared,}

\item{species}{character, supported values are "hs" and "mm"}

\item{condition_var}{symbol or character, the variable name for this comparison}

\item{gene_type}{character, the type of gene identifier}
}
\value{
a DeeDeeExperiment or SummarizedExperiment
}
\description{
Calculates the GSEA enrichments with the counts within a summarizedExperiment
or DeeDeeExperiment and adds them in the respective slots. It follows
the \href{https://www.pnas.org/doi/10.1073/pnas.0506580102}{original signal-to-noise ratio of the method}; other approaches for
ranking of genes are available in other implementations,
such as the \code{\link[clusterProfiler:GSEA]{clusterProfiler::GSEA()}} implementation which calls for
logFC ranked genes.
}
\examples{

library(airway)
library(DeeDeeExperiment)
data(airway)
data("baseline_de", package = "exploreSE")

se_with_de <- addDEA(DeeDeeExperiment(airway), baseline)
se_with_gsea <- get.gsea(NAME = "baseline",
                         obj = se_with_de,
                         type = "HALLMARK",
                         condition_var = "dex",
                         conditions = c("trt", "untrt"),
                         gene_type = "ENSEMBL")
}
